init_isp:                                       ;void init_isp() {
    CLR A
    MOV R0, #0Ah
    MOVX @R0, A             ;   isp_state = 0;
    INC R0
    LCALL mov_dword         ;   isp_ptr = 0; // mov_dword(&isp_ptr);
    NOP
    NOP
    NOP
    NOP
    MOV R0, #0Fh
    LCALL mov_dword         ;   isp_count = 0; // mov_dword(&isp_count);
    NOP
    NOP
    NOP
    NOP
    RET                     ;}


isp:                                            ;byte __register(R7) isp(byte __register(R7) mode, byte __register(R5) data) {
    MOV R0, #0Dh
    MOVX A, @R0
    MOV IFADRH, A
    INC R0
    MOVX A, @R0
    MOV IFADRL, A             ;   IFADRH:IFADRL = Xw0D;
    MOV A, R7
    CJNE A, #2h, L0292      ;   if (mode == 2)
    XCH A, R6
    MOV A, R5
    XCH A, R6
    MOV IFD, R6            ;       IFD = data;
L0292:                                          ;   }
    MOV A, R7
    ORL A, #80h
    MOV 0E7h, A             ;   ISPCR = mode | ISPEN;
    MOV SCMD, #46h          ;   SCMD = 0x46;
    MOV SCMD, #0B9h         ;   SCMD = 0xB9;
    CLR A
    MOV ISPCR, A             ;   ISPCR = 0;
    MOV A, R7               ;
    CJNE A, #1h, L0293      ;   if (mode == 1) {
    MOV R7, IFD
    RET                     ;       return IFD;
L0293:                                          ;   }
    MOV R7, #0h             ;   return 0;
    RET                     ;}

isp_reprogram:                                  ;void isp_reprogram(byte __register(R7) size /*always 0x40*/) {
    MOV R0, #65h
    MOV A, R7
    MOVX @R0, A             ;   X65 = size; // 0x40
    MOV R0, #0Ah
    MOVX A, @R0
    JNZ L0314               ;   if (isp_state == 0) {
    MOV R0, #17h
    MOVX A, @R0
    MOV R7, A
    MOV R0, #0Ah
    MOVX @R0, A             ;       isp_state = request.bmRequestType;
    ADD A, #89h
    JZ L0315                ;       switch (request.bmRequestType) {
    ADD A, #11h
    JZ L0316
    LJMP L0317

L0316:
    SJMP L0318

L0315:                                          ;       case 0x77: // Host-to-device, Reserved, Reserved
    MOV R0, #0Dh
    MOV A, #28h
    MOVX @R0, A
    INC R0
    CLR A
    MOVX @R0, A             ;           isp_ptr = &macros;
    MOV R0, #12h
    MOV A, #8h
    MOVX @R0, A             ;           LOBYTE(isp_count) = 8;
    LCALL isp_erase_pages   ;           isp_erase_pages(); // 8 pages at [0x2800, 0x3800)
                            ;           // fallthrough;
L0318:                                          ;       case 0x66: // Host-to-device, Reserved, Reserved
    MOV R0, #0Dh
    MOV A, #28h
    MOVX @R0, A
    INC R0
    CLR A
    MOVX @R0, A             ;           isp_ptr = &macros;
    MOV R0, #11h
    MOV A, #10h
    MOVX @R0, A
    INC R0
    CLR A
    MOVX @R0, A             ;           LOWORD(isp_count) = 0x1000;
    RET                     ;           return;
                            ;       default: return;
L0314:                                          ;   }   }
    MOV R0, #65h
    MOVX A, @R0
    ADD A, #0FEh
    MOVX @R0, A             ;   X65 -= 2; // r7 - 2
    MOVX A, @R0
    MOV R7, A
    CLR A
    MOV R4, A
    MOV R5, A
    MOV R6, A
    MOV R0, #0Fh
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    XCH A, R3
    MOV R0, A
    SETB C
    LCALL dword_compare
    JNC L0322               ;   if (X65 + 1 /*r7 - 1*/ > isp_count) { // dword_compare(isp_count, 0:0:0:X65, true)
    MOV R0, #12h
    MOVX A, @R0
    MOV R0, #65h
    MOVX @R0, A             ;       X65 = isp_count;
    CLR A
    MOV R0, #0Ah
    MOVX @R0, A             ;       isp_state = 0;
L0322:                                          ;   }
    MOV R0, #0Fh
    MOVX A, @R0
    MOV R4, A
    INC R0
    MOVX A, @R0
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R6, A
    INC R0
    MOVX A, @R0
    MOV R7, A
    MOV A, R7
    PUSH ACC
    MOV R0, #65h
    MOVX A, @R0
    MOV R3, A
    POP ACC
    MOV R7, A
    CLR C
    MOV A, R7
    SUBB A, R3
    MOV R7, A
    MOV A, R6
    SUBB A, #0h
    MOV R6, A
    MOV A, R5
    SUBB A, #0h
    MOV R5, A
    MOV A, R4
    SUBB A, #0h
    MOV R4, A
    MOV R0, #0Fh
    LCALL dword_write       ;   isp_count = isp_count - X65; // dword_write(0x0F, isp_count - X65)

    CLR A
    MOV R0, #13h
    MOVX @R0, A
L0323:
    MOV R0, #65h
    MOVX A, @R0
    MOV R7, A
    MOV R0, #13h
    MOVX A, @R0
    MOV R6, A
    CLR C
    SUBB A, R7
    JNC L0317               ;   for (byte __volatile(X13) i = 0; i < X65; ++i) {
    MOV A, #19h
    ADD A, R6
    MOV R0, A
    MOVX A, @R0
    MOV R5, A
    MOV R7, #2h
    LCALL isp               ;       isp(IspModeWrite, ((byte*)(&request)+2)[i]);
    MOV R0, #0Bh
    MOVX A, @R0
    MOV R4, A
    INC R0
    MOVX A, @R0
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R6, A
    INC R0
    MOVX A, @R0
    ADD A, #1h
    MOV R7, A
    CLR A
    ADDC A, R6
    MOV R6, A
    CLR A
    ADDC A, R5
    MOV R5, A
    CLR A
    ADDC A, R4
    MOV R4, A
    MOV R0, #0Bh
    LCALL dword_write       ;       isp_ptr = isp_ptr + 1; // dword_write(0x0B, isp_ptr + 1)
    MOV R0, #13h
    MOVX A, @R0
    INC A
    MOVX @R0, A
    SJMP L0323              ;   }
L0317:
    RET                     ;}
    

memwrite:                                       ;void memwrite(R3 == 1,    byte* __register(DPTR) Xbase16, word __register(R2:R1) offset16, byte __register(A) value)
                            ;       or    (R3 == 0,    byte* __register(DPL)  base8,   byte __register(R1)    offset8,  byte __register(A) value)
                            ;       or    (R3 == 0xFE, byte* __register(DPL)  Xbase8,  byte __register(R1)    offset8,  byte __register(A) value)
                            ;{
    MOV R0, A
    CJNE R3, #1h, L0306     ;   if (mode == 1) {
    MOV A, DPL
    ADD A, R1
    MOV DPL, A
    MOV A, DPH
    ADDC A, R2
    MOV DPH, A
    MOV A, R0
    MOVX @DPTR, A           ;       Xbase16[offset16] = value;
    RET

L0306:                                          ;   }
    JNC L0307               ;   else if (mode < 1) {
    MOV A, R1
    ADD A, DPL
    XCH A, R0
    MOV @R0, A              ;       base8[offset8] = value;
    RET

L0307:                                          ;   }
    CJNE R3, #0FEh, L0308   ;   else if (mode == 0xFE) {
    MOV A, R1
    ADD A, DPL
    XCH A, R0
    MOVX @R0, A             ;       Xbase8[offset8] = value;
L0308:                                          ;   }
    RET                     ;}

dword_compare:                                  ;{bool __register(C), // true if lhs <  rhs + carry
                            ; byte __register(A)} // 0    if lhs == rhs + carry
                            ;dword_compare(dword __register(R0:R1:R2:R3) lhs,
                            ;              dword __register(R4:R5:R6:R7) rhs,
                            ;              bool __register(C) carry)
    MOV A, R3               ;{
    SUBB A, R7
    MOV B, A
    MOV A, R2
    SUBB A, R6
    ORL B, A
    MOV A, R1
    SUBB A, R5
    ORL B, A
    MOV A, R0
    SUBB A, R4              ;   dword j:k:l:m = lhs - rhs - carry;
    ORL A, B                ;   return j | k | l | m;
    RET                     ;}

dword_write:                                    ;void dword_write(dword* __register(R0) p, dword __register(R4:R5:R6:R7) value) {
    MOV A, R4
    MOVX @R0, A
    INC R0
    MOV A, R5
    MOVX @R0, A
    INC R0
    MOV A, R6
    MOVX @R0, A
    INC R0
    MOV A, R7
    MOVX @R0, A             ;   *p = value;
    RET                     ;}

mov_dword:                                      ;void mov_dword(dword* __register(R0) Xptr) {
    POP DPH
    POP DPL                 ;   DPTR = return_ip;
    CLR A
    MOVC A, @A+DPTR
    MOVX @R0, A
    INC R0                  ;   *Xptr++ = C:DPTR[0];
    MOV A, #1h
    MOVC A, @A+DPTR
    MOVX @R0, A
    INC R0                  ;   *Xptr++ = C:DPTR[1];
    MOV A, #2h
    MOVC A, @A+DPTR
    MOVX @R0, A
    INC R0                  ;   *Xptr++ = C:DPTR[2];
    MOV A, #3h
    MOVC A, @A+DPTR
    MOVX @R0, A             ;   *Xptr = C:DPTR[3];
    MOV A, #4h
    JMP @A+DPTR             ;   return at DPTR+4;
                            ;}

memset:                                         ;void memset(R6 == R7 == 0) // nop
                            ;  or memset(R3 == 1, byte* __register(R2:R1) Xptr, byte __register(R6) size, R7 == 0, byte __register(R5) value) // fill size × 256 bytes at Xptr with value
                            ;  or memset(R3 == 1, byte* __register(R2:R1) Xptr, byte __register(R6) r6, byte __register(R7) r7, byte __register(R5) value) // fill r6+1 × r7 bytes at Xptr with value
                            ;  or memset(R3 == 0, byte* __register(R1) ptr, byte __register(R7) size, byte __register(R5) value) // fill size bytes at ptr with value
                            ;  or memset(R3 == 0xFE, byte* __register(R1) Xptr, byte __register(R7) size, byte __register(R5) value) // fill size bytes at Xptr with value
                            ;{
    MOV A, R7
    ORL A, R6
    JZ L0029                ;   if (r6 == 0 && r7 == 0) return;
    MOV A, R7
    JZ L0030                ;   if (r7 != 0)
    INC R6                  ;       R6 = r6 + 1;
L0030:
    MOV A, R5
    CJNE R3, #1h, L0031     ;   if (r3 == 1) {
    MOV DPL, R1
    MOV DPH, R2
L0032:                                          ;       while (R6 --> 0) while (r7 --> 0) {
    MOVX @DPTR, A
    INC DPTR                ;           *Xptr++ = value;
    DJNZ R7, L0032
    DJNZ R6, L0032          ;       }
L0029:
    RET                     ;       return;

L0031:                                          ;   } else
    MOV B, R1
    JNC L0033               ;   if (r3 < 1) {
L0034:                                          ;       while (r7 --> 0) {
    MOV @R1, A
    INC R1                  ;           *ptr++ = value;
    DJNZ R7, L0034          ;       }
    MOV R1, B
L0035:
    RET                     ;       return;

L0033:                                          ;   }
    CJNE R3, #0FEh, L0035   ;   if (r3 == 0xFE) {
L0036:                                          ;       while (r7 --> 0) {
    MOVX @R1, A
    INC R1                  ;           *Xptr++ = value;
    DJNZ R7, L0036          ;       }
    MOV R1, B
    RET                     ;}  }

    
    


isp_read_block:                                 ;void isp_read_block() {
    MOV R0, #0Ah
    MOVX A, @R0
    ADD A, #9Ah             ;   switch (isp_state) {
    JZ L0284
    ADD A, #11h
    JZ L0285
    LJMP L0286

L0285:                                          ;   case 0x55:
    MOV R0, #17h
    MOV A, #55h
    MOVX @R0, A             ;       report[0] = 0x55;
    INC R0
    MOV A, #0AAh
    MOVX @R0, A             ;       report[1] = 0xAA;
    CLR A
    INC R0
    MOVX @R0, A             ;       report[2] = 0;
    INC R0
    MOV A, #28h
    MOVX @R0, A             ;       report[3] = 0x28;
    CLR A
    LJMP L0287              ;       isp_state = 0; return;

L0284:                                          ;   case 0x66:
    CLR A
    MOV R0, #13h
    MOVX @R0, A
L0290:                                          ;       for (byte __volatile(X13) i = 0; i < 0x40; ++i) {
    CLR A
    MOV R5, A
    MOV R7, #1h
    LCALL isp
    MOV R0, #13h
    MOVX A, @R0
    ADD A, #17h
    MOV R0, A
    MOV A, R7
    MOVX @R0, A             ;           X17[i] = isp(IspModeRead);
    MOV R0, #0Bh
    MOVX A, @R0
    MOV R4, A
    INC R0
    MOVX A, @R0
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R6, A
    INC R0
    MOVX A, @R0
    ADD A, #1h
    MOV R7, A
    CLR A
    ADDC A, R6
    MOV R6, A
    CLR A
    ADDC A, R5
    MOV R5, A
    CLR A
    ADDC A, R4
    MOV R4, A
    MOV R0, #0Bh
    LCALL dword_write       ;           ++isp_ptr; // dword_write(&isp_ptr, isp_ptr + 1);
    MOV R0, #13h
    MOVX A, @R0
    INC A
    MOVX @R0, A
    MOVX A, @R0
    CLR C
    SUBB A, #40h
    JC L0290                ;       }
    MOV R0, #0Fh
    MOVX A, @R0
    MOV R4, A
    INC R0
    MOVX A, @R0
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R6, A
    INC R0
    MOVX A, @R0
    MOV R7, A
    MOV A, R7
    PUSH ACC
    INC R0
    MOVX A, @R0
    MOV R3, A
    POP ACC
    MOV R7, A
    CLR C
    MOV A, R7
    SUBB A, R3
    MOV R7, A
    MOV A, R6
    SUBB A, #0h
    MOV R6, A
    MOV A, R5
    SUBB A, #0h
    MOV R5, A
    MOV A, R4
    SUBB A, #0h
    MOV R4, A
    MOV R0, #0Fh
    LCALL dword_write       ;       isp_count -= i; // dword_write(&isp_count, isp_count - i);
    CLR A
    MOV R7, A
    MOV R6, A
    MOV R5, A
    MOV R4, A
    MOV R0, #0Fh
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    XCH A, R3
    MOV R0, A
    CLR C
    LCALL dword_compare
    JNZ L0286               ;       if (isp_count == 0) // dword_compare(isp_count, 0, false)
L0287:
    MOV R0, #0Ah
    MOVX @R0, A             ;            isp_state = 0;
L0286:                                          ;   }
    RET                     ;}

    
isp_erase_pages:                                ;void isp_erase_pages() {
    CLR A
    MOV R0, #13h
    MOVX @R0, A
L0321:
    MOV R0, #12h
    MOVX A, @R0
    MOV R7, A
    INC R0
    MOVX A, @R0
    CLR C
    SUBB A, R7
    JNC L0320               ;   for (byte __volatile(X13) i = 0; i < LOBYTE(isp_count); ++i) {
    CLR A
    MOV R5, A
    MOV R7, #3h
    LCALL isp               ;       isp(IspModePageErase);
    MOV R0, #0Dh
    MOVX A, @R0
    ADD A, #2h
    MOVX @R0, A             ;       isp_ptr += 0x200;
    MOV R0, #13h
    MOVX A, @R0
    INC A
    MOVX @R0, A
    SJMP L0321              ;   }
L0320:
    RET                     ;}