

; 
scan_column:                                    ;void scan_column() {
    MOV R0, #colIndex
    MOV A, @R0
    CJNE A, #NCOLUMNS, L0149     ;   if (column_index == sizeof(key_matrix))
    CLR A
    MOV @R0, A              ;       column_index = 0; // scan 18 columns over and over?
L0149:
    MOV R0, #colIndex
    MOV A, @R0
    MOV R7, A
    LCALL read_column       ;   byte __register(R7) raw_value = read_column(column_index);

    MOV A, colIndex             ;        R6 = column_index
    MOV R6, A
    ADD A, #scanResults
    MOV R0, A               ;       R0 = &key_matrix[column_index]
    MOV A, @R0
    MOV R5, A               ;       R5 = key_matrix[column_index]
    XRL A, R7
    MOV R7, A               ;   byte __register(R7) delta = raw_value ^ key_matrix[column_index];
    MOV A, R6
    ADD A, #0BCh
    
    ; Debouncing logic, meant I think to be a 2-bit counter 
    ; for each position in the matrix, gated by the changes from current, so changes
    ; emerge after 4 scan cycles.
    ; Looks like changes to A and B are in the wrong order?
    MOV R0, A               ;       R0 = &clockA[column_index].
    ADD A, #NCOLUMNS
    MOV R1, A               ;       R1 = &clockB[column_index].
    MOV A, @R0
    XRL A, @R1              ;   
    ANL A, R7						
    MOV @R0, A              ;   A = (A ^ B) & delta
    MOV A, @R1						
    CPL A                   ;   
    ANL A, R7
    MOV @R1, A              ;    B = ~B & delta
    MOV A, R7						
    CPL A					; 
    ORL A, @R0				; ~d | A | B
    ORL A, @R1
    CPL A                   ;   byte __register(A) changes = ~(~delta | clockA[column_index] | clockB[column_index]);
    XRL A, R5
    MOV R0, #colValue
    MOV @R0, A              ;   column_value = key_matrix[column_index] ^ changes;
    NOP
    CLR A
    MOV R0, #phantomFlag
    MOV @R0, A              ;   phantom = false;
    MOV R0, #colValue
    MOV A, @R0
    JZ L0151                ;   if (column_value) {
    	
    ;LCALL check_phantom             ;		for testing multiple keys in same column?
    ;MOV R0, #phantomFlag
    ;MOV A, R7
    ;MOV @R0, A              ;       phantom = f0152(); // always 0 :/
L0151:                                          ;   }
    ;MOV R0, #phantomFlag
    ;MOV A, @R0
    MOV A, #0	; simplify
    
    JNZ L0153               ;   if (not phantom) { // always
    MOV R0, #colIndex
    MOV A, @R0
    ADD A, #scanResults
    MOV R0, A
    MOV A, @R0
    MOV R0, #colTemp
    MOV @R0, A              ;       old_column_value = key_matrix[column_index];
    LCALL decode_fn         ;       decode_fn();
    MOV R0, #colValue
    MOV A, @R0
    MOV R7, A
    DEC R0
    MOV A, @R0
    ADD A, #scanResults
    MOV R0, A
    MOV A, R7
    MOV @R0, A              ;       key_matrix[column_index] = column_value;
    LCALL decode_numlock    ;       decode_numlock();
L0153:                                          ;   }
    LCALL scan_delay        ;   scan_delay();
    MOV R0, #colIndex
    INC @R0                 ;   ++column_index;
    RET                     ;}

    

; Removed defaulting scheme for layers fn+num->fn->num; fn->top
do_get_keycode:                                 ;byte __register(R7) do_get_keycode(byte __register(R7) keyindex, byte __register(A) layer)
    MOV DPTR, #JUMPTAB1
    ANL A, #7h
    MOV B, #5
    MUL AB
    JMP @A+DPTR
JUMPTAB1:
	MOV DPTR, #pc_keycodes
	SJMP GETCODE
	MOV DPTR, #pc_num_keycodes
	SJMP GETCODE
	MOV DPTR, #pc_fn_keycodes
	SJMP GETCODE
	MOV DPTR, #pc_fn_keycodes
	SJMP GETCODE
	MOV DPTR, #mac_keycodes
	SJMP GETCODE
	MOV DPTR, #mac_num_keycodes
	SJMP GETCODE
	MOV DPTR, #mac_fn_keycodes
	SJMP GETCODE
	MOV DPTR, #mac_fn_keycodes
GETCODE:
	MOV A, R7	; get index
	RLC A		; * 2
	JNC nocarry	
	INC DPH		; adjust DPTR if > 255
nocarry:
	MOV B, A		
    MOVC A, @A+DPTR		; get modifiers
    ORL keyModifiers, A
    MOV A, B
    INC DPTR
    MOVC A, @A+DPTR		; get keycode
	MOV R7, A  
	RET
	



decode_numlock:                                 ;void decode_numlock() {
    CLR A
    MOV R0, #53h
    MOV @R0, A
    MOV R0, #56h
    MOV @R0, #1h
L0160:                                          ;   for (byte __volatile(v53) i = 0, __volatile(v56) mask = 1;
                            ;       i < 8; ++i, mask <<= 1) {
    MOV R0, #53h
    MOV A, @R0
    CLR C
    SUBB A, #8h
    JC L0156
    LJMP L0157

L0156:
    MOV R1, #colValue
    MOV A, @R1
    MOV R0, #56h
    ANL A, @R0
    JNZ L0158               ;       if (column_value & mask) {
    LJMP L0159

L0158:
    MOV R0, #colIndex
    MOV A, @R0
    RLC A
    RLC A
    RLC A
    ANL A, #0F8h
    MOV R0, #53h
    ADD A, @R0
    MOV R0, #keyIndex
    MOV @R0, A              ;           byte __volatile(v3B) key_index = column_index << 3 + i;
    MOV R7, A
    LCALL get_held_keycode  ;           R7 = get_held_keycode(key_index);
    MOV R0, #keyCode
    MOV A, R7
    MOV @R0, A              ;           keycode = R7
    CLR C                   ;           // keycode is still in R7 and A
    SUBB A, #59h
    JC L0166
    SUBB A, #0Bh
    JNC L0166               ;           if (0x59 <= keycode <= 0x63) { // NumLock-dependent
    ;LCALL trigger_numlock   ;               trigger_numlock();
L0166:                                          ;           } // if NumLock and kb_mode == 0x5A
    LCALL store_key         ;           store_key();
L0159:                                          ;       } // if
    MOV R0, #53h
    INC @R0
    MOV R0, #56h
    MOV A, @R0
    ADD A, ACC
    MOV @R0, A
    SJMP L0160              ;   } // for
L0157:
    RET                     ;}


; For a held key, gets layer stored in pressed_keys, and then calls do_get_keycode
; For a newly pressed key, calls get_layer then do_get_keycode
get_changed_keycode:                            ;byte __register(R7) get_changed_keycode(byte __register(R7) keyindex) { // R1 A
    MOV A, colValue
    ANL A, 56h              ;   if (column_value & mask) {
    JNZ get_held_keycode__notfound
                            ;       return get_pressed_keycode(keyindex);
                            ;   } else {
                            ;       return get_held_keycode(keyindex)
                            ;   }
                            ;}

get_held_keycode:                               ;byte __register(R7) get_held_keycode(byte __register(R7) keyindex) { // R1 A
    MOV R1, #pressedKeys           ;   for (PressedKey* __register(R1) p = &pressed_keys[0]; p != &pressed_keys[15]; ++p) {
ghkkLoop:
    MOV A, @R1
    INC R1
    XRL A, R7				; found?
    JNZ ghkkNext ;    if (p->keyindex == keyindex) {
    MOV A, @R1
    LJMP do_get_keycode     ;           return do_get_keycode(keyindex, p->layer);
ghkkNext:                         ;       }
    INC R1
    CJNE R1, #0FEh, ghkkLoop
                            ;   }
get_held_keycode__notfound:
    LJMP get_pressed_keycode;   return get_pressed_keycode(keyindex); // not found
                            ;}
            

get_pressed_keycode:                            ;byte __register(R7) get_pressed_keycode(byte __register(R7) keyindex) { // R0 R1 A DPTR R7
    LCALL get_layer
    LJMP do_get_keycode     ;   return do_get_keycode(keyindex, get_layer());
                            ;}

;;; Store key and layer for the key in the first empty location of pressedKeys
store_pressed_key:                              ;void store_pressed_key(byte __register(R0) keyindex) { // R0 R1 A
    MOV R1, #pressedKeys           ;   for (PressedKey* __register(R1) p = &pressed_keys[0]; p != &pressed_keys[15]; ++p) {
spkLoop:
    MOV A, @R1
    JNZ spkNext;    		
    MOV A, R0				; found space
    MOV @R1, A              ; store the key
    INC R1
    LCALL get_layer
    MOV @R1, A              ; store the layer
    RET                     
spkNext:                        
    INC R1
    INC R1
    CJNE R1, #0FEh, spkLoop
    RET                    

    
;;; Remove key from pressed keys
clear_pressed_key:                              ;void clear_pressed_key(byte __register(R0) keyindex) { // R1 A
    MOV R1, #pressedKeys           ;   for (PressedKey* __register(R1) p = &pressed_keys[0]; p != &pressed_keys[15]; ++p) {
clear_pressed_key__loop:
    MOV A, R0
    XRL A, @R1
    JNZ cpkNext
                            ;       if (p->keyindex == keyindex) {
    MOV @R1, A              ;           p->keyindex = 0;
    RET                     ;           return;
cpkNext:                        ;       }
    INC R1
    INC R1
    CJNE R1, #0FEh, clear_pressed_key__loop
                            ;   }
    RET                     ;}


;;; in: byte __volatile(v23) column_index, __volatile(v24) column_value, __volatile(v53) i, __volatile(v56) mask;
;;; inout: struct PressedKey { byte keyindex; byte layer; } __volatile(vE0) pressed_keys[15];
;;; uses registers: A R0 R1

; Add newly pressed key, or remove newly released key from pressed keys
update_pressed_keys:                            ;void update_pressed_keys() {
    MOV A, 23h
    RL A
    RL A
    RL A
    ORL A, 53h
    MOV R0, A               ;   byte __register(R0) keyindex = column_index << 3 | i;
    MOV A, colValue
    ANL A, 56h              ;   if (column_value & mask) {
    JNZ store_pressed_key   ;       store_pressed_key(keyindex);
                            ;   } else {
    SJMP clear_pressed_key  ;       clear_pressed_key(keyindex);
                            ;   }
                            ;}






; calls get_changed_keycode; update_pressed_keys
decode_fn:                                      ;void decode_fn() {
    CLR A
    MOV R0, #53h
    MOV @R0, A
    MOV R0, #56h
    MOV @R0, #1h
    MOV R0, #colChanges
    MOV A, @R0
    MOV R1, #colValue
    XRL A, @R1
    MOV @R0, A              ;   column_changed = old_column_value ^ column_value;
L0196:                                          ;   for (byte __volatile(v53) i = 0, __volatile(v56) mask = 1; i < 8; ++i, mask <<= 1) {
    MOV R0, #53h
    MOV A, @R0
    CLR C
    SUBB A, #8h
    JC L0192
    LJMP L0193
L0192:
    MOV R1, #colChanges
    MOV A, @R1
    MOV R0, #56h
    ANL A, @R0
    JNZ L0194
    LJMP cont              ;       if (column_changed & mask) {
L0194:
    MOV R0, #colIndex
    MOV A, @R0
    RLC A
    RLC A
    RLC A
    ANL A, #0F8h
    MOV R0, #53h
    ADD A, @R0
    MOV R0, #keyIndex
    MOV @R0, A              ;           byte __volatile(v3B) key_index = column_index << 3 + i;
    MOV R7, A
    LCALL get_changed_keycode ;         R7 = get_changed_keycode(key_index);
    LCALL update_pressed_keys ;         update_pressed_keys();
    MOV R0, #keyCode
    MOV A, R7
    MOV @R0, A              ;           keycode = R7;
                             
    CJNE A, #_TENUM, checkFunKey       
    MOV A, colValue
    ANL A, 56h
    JZ clrNum
    MOV A, #01h
clrNum:
    MOV R0, #layerKeysDown
	MOVX @R0, A
    SJMP cont    
    
checkFunKey:                                 
    CJNE A, #_TEFUN, checkNumKey    ;          
    MOV A, colValue
    ANL A, 56h
    JZ clrFun
    MOV A, #02h
clrFun:
    MOV R0, #layerKeysDown
	MOVX @R0, A
    SJMP cont
    
checkNumKey:
    CJNE A, #_TENUM, checkMediaKeys    ;           if (keycode == 0xDE) { // IntNum
    MOV A, colValue
    ANL A, 56h
    JZ cont                ;               if (column_value & mask) {
    CPL P3.5                ;                   P3./NUM = not P3./NUM;                                          ;               }
    SJMP cont              ;               continue;

checkMediaKeys:                                          ;           }
    MOV R0, #keyCode
    MOV A, @R0
    MOV R6, A
    CLR C
    SUBB A, #MEDIA_FIRST
    JC L0209                ;           if (keycode >= 0xE8 // MediaFirst
    MOV A, R6
    SETB C
    SUBB A, #MEDIA_LAST
    JNC L0209               ;               and keycode <= 0xFE) // MediaLast
                            ;           {
    MOV A, colValue
    ANL A, 56h
    JZ decode_fn__media_up  ;               if (column_value & mask) { // down
    MOV R0, #46h
    MOV @R0, #1h            ;                   media_report_ready = 1;
    INC R0
    MOV @R0, keyCode            ;                   media_keycode = keycode;
    LCALL mediaKeycodeDown        ;                   processMediaKeycode();
    SJMP cont              ;                   continue;
decode_fn__media_up:                            ;               } else { // up
    LCALL mediaKeycodeUp           ;                   stop_fn();
    SJMP cont              ;                   continue;
                            ;               }
                            ;           }

L0209:
    MOV R0, #normalKey
    MOV @R0, #1h            ;           normal_key = true;
cont:                                          ;       }
    MOV R0, #53h
    INC @R0
    MOV R0, #56h
    MOV A, @R0
    ADD A, ACC
    MOV @R0, A
    LJMP L0196              ;   } // for i, mask
L0193:
    RET                     ;}



; NB must be before processMediaKeycode - does not return
mediaKeycodeUp:                                        ;void stop_fn() {
    MOV R0, #46h
    MOV @R0, #1h            ;   media_report_ready = 1;
    CLR A
    INC R0
    MOV @R0, A              ;   media_keycode = 0;
                            ;   hid_report2[0] = 1; hid_report2[1] = 0;
                            ;}
mediaKeycodeDown:         ;void processMediaKeycode() {
    MOV R0, #47h
    MOV A, @R0
    CLR C
    SUBB A, #0E8h
    JC L9000                ;    if (media_keycode >= 0xE8) {
    MOV R0, #48h
    MOV @R0, #1h            ;        hid_report2[0] = 1;
    INC R0
    INC A
    MOV @R0, A              ;        hid_report2[1] = media_keycode - 0xE7;
    RET                     ;        return;
L9000:                                          ;    }
    MOV R0, #48h
    MOV @R0, #1h            ;    hid_report2[0] = 1;
    INC R0
    CLR A
    MOV @R0, A              ;    hid_report2[1] = 0;
    RET                     ;}
    
    
;==========================================================================================
get_layer:                                      ;byte __register(A) get_layer() { // R0
    MOV R0, #layerKeysDown
    MOVX A, @R0
    ;JZ L9503
    ;MOV A, #2h
L9503:                                          ;   byte __register(A) layer = fn_down ? 2 : 0;
    JNB 0EAh, L9501
    ORL A, #4h
L9501:                                          ;   layer |= P4./DIP1 ? 4 : 0;
    JB P3.5, L9502
    INC A
L9502:                                          ;   layer |= not P3./NUM ? 1 : 0;
    RET                     ;   return layer;
                            ;}


; Store normal keys in keys_down array for transmission. Ignore modifiers, media keys
; and layer keys.
store_key:                                      ;void store_key() {
    MOV R0, #keyCode
    MOV A, @R0
    MOV R7, A
    ANL A, #0F8h
    XRL A, #0E0h
    JNZ L9602               ;   switch (keycode) {
                            ;   case 0xE0: case 0xE1: case 0xE2: case 0xE3:
                            ;   case 0xE4: case 0xE5: case 0xE6: case 0xE7: // Modifiers
    MOV R6, #1h
    MOV A, R7
    ADD A, #20h
    JZ L9600
    XCH A, R6
L9601:
    RL A
    DJNZ R6, L9601
    XCH A, R6
L9600:
    MOV R0, #keyModifiers
    MOV A, @R0
    ORL A, R6
    MOV @R0, A              ;       key_modifiers |= 1 << (keycode - 0xE0);
    RET                     ;       return;
L9602:
    MOV A, R7
    CLR C
    SUBB A, #0E8h
    JNC L0170               ;   case 0xE8: case 0xE9: case 0xEA: case 0xEB:
                            ;   case 0xEC: case 0xED: case 0xEE: case 0xEF:
                            ;   case 0xF0: case 0xF1: case 0xF2: case 0xF3:
                            ;   case 0xF4: case 0xF5: case 0xF6: case 0xF7:
                            ;   case 0xF8: case 0xF9: case 0xFA: case 0xFB:
                            ;   case 0xFC: case 0xFD: case 0xFE: case 0xFF: // Media keys
                            ;       return;
    MOV A, R7
    SUBB A, #_TENUM         ;   // carry was set
    JZ L0170                ;   case 0xDF: // Fn
    INC A
    JZ L0170                ;   case 0xDE: // IntNum
                            ;       return;
                            
                                        ;   default:
    MOV R0, #4Ah
    MOV A, @R0
    MOV R7, A
    CJNE A, #6h, L0171      ;       if (keydown_index == 6) {
    MOV R0, #phantomFlag
    MOV @R0, #1h            ;           phantom = true;
    RET                     ;       }

L0171:                                          ;       else {
    MOV R0, #keyCode
    MOV A, @R0
    MOV R6, A
    MOV A, #4Dh
    ADD A, R7
    MOV R0, A
    MOV A, R6
    MOV @R0, A
    MOV R0, #4Ah
    INC @R0                 ;           keys_down[keydown_index++] = keycode;
    CLR A
    MOV R0, #keyCode
    MOV @R0, A              ;           keycode = 0;
L0170:
    RET                     ;}  }   }

	
process_key:                                    ;void process_key() {
    MOV R0, #15h
    MOVX A, @R0
    JNZ L0021               ;   if (configured) {
    LJMP pkRetn
L0021:
    MOV R0, #colIndex
    MOV A, @R0
    XRL A, #NCOLUMNS
    JZ L0023                ;       if (column_index == sizeof(key_matrix)) {
    LJMP L0024
L0023:
    MOV R0, #phantomFlag
    MOV A, @R0
    JZ NOPHANTOM                ;           if (phantom) {
    CLR A
    MOV R0, #keyModifiers
    MOV @R0, A              ;               key_modifiers = 0;
    INC R0
    MOV @R0, A              ;               hid_reserved = 0;
    INC R0
    MOV @R0, #1h            ;               keys_down[0] = 1;
    INC R0
    MOV @R0, #1h            ;               keys_down[1] = 1;
    INC R0
    MOV @R0, #1h            ;               keys_down[2] = 1;
    INC R0
    MOV @R0, #1h            ;               keys_down[3] = 1;
    INC R0
    MOV @R0, #1h            ;               keys_down[4] = 1;
    INC R0
    MOV @R0, #1h            ;               keys_down[5] = 1;
    CLR EA                  ;               __uninterrupted {
    MOV DPTR, #EPINDEX
    INC A
    MOVX @DPTR, A           ;                   EPINDEX = 1;
    CLR A
    INC R0
    MOV @R0, A
L0038:                                          ;                   for (byte __volatile(v53) i = 0; i != 8; ++i) {
    MOV R0, #53h
    MOV A, @R0
    ADD A, #4Bh
    MOV R0, A
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                       TXDAT = hid_report[i];
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    CJNE A, #8h, L0038      ;                   }
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;                   usb1_transmitting = 1;
    MOV R0, #53h
    MOV A, @R0
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;                   TXCNT = i; // 8
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;                   EPINDEX = 0;
    SETB ENABLE_ANY                 ;               }
L0042:                                          ;               do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0039                ;               } while (usb1_transmitting == 1);
    LJMP L0024

L0039:
    SJMP L0042

NOPHANTOM:                                          ;           } else // not phantom
    MOV R0, #normalKey
    MOV A, @R0
    JNZ L0043               ;           if (normal_key) {
    LJMP L0024

L0043:
    LCALL process_shift_f12 ;               process_shift_f12();
    MOV R0, #kbMode
    MOV A, @R0
    XRL A, #5Ah
    JZ L0045                ;               if (kb_mode == KBMODE_NORMAL) {
    LJMP L0046

L0045:

    MOV R0, #4Dh
    MOV A, @R0
    CJNE A, #_WINBRK, L9401    ;                   if (keys_down[0] == 0xAD) { // WinBrk
    MOV A, #80h
    SJMP L9402              ;                       key_modifiers.RWin = true;
                            ;                       keys_down[0] = 0x48; // Pause
                            ;                   } else
L9401:
    CJNE A, #_CTLBRK, L0104    ;                   if (keys_down[0] == 0xAE) { // CtrlBrk
    MOV A, #10h
L9402:
    MOV R0, #keyModifiers
    ORL A, @R0
    MOV @R0, A              ;                       key_modifiers.RCtrl = true;
    MOV R0, #4Dh
    MOV @R0, #48h           ;                       keys_down[0] = 0x48; // Pause
L0104:                                          ;                   }
    ;LCALL numlock_on        ;                   numlock_on();
    ;MOV R0, #5h
    ;MOVX A, @R0
    ;CJNE A, #88h, L0115     ;                   if (numlock_state == 0x88) {
    ;CLR A
    ;DEC R0
    ;MOVX @R0, A             ;                       numlock_timer = 0;
    ;INC R0
    ;MOV A, #0CCh
    ;MOVX @R0, A             ;                       numlock_state = 0xCC;
L0115:                                          ;                   }
    CLR EA                  ;                   __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #1h
    MOVX @DPTR, A           ;                       EPINDEX = 1;
    CLR A
    MOV R0, #53h
    MOV @R0, A
L0116:                      ; for (byte __volatile(v53) i = 0; i != 8; ++i) {
    MOV R0, #53h
    MOV A, @R0
    ADD A, #4Bh
    MOV R0, A
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                           TXDAT = hid_report[i];
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    CJNE A, #8h, L0116      ;                       }
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;                       usb1_transmitting = 1;
    MOV R0, #53h
    MOV A, @R0
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;                       TXCNT = i; // 8
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;                       EPINDEX = 0;
    SETB ENABLE_ANY                 ;                   }
L0117:                                          ;                   do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0117                ;                   } while (usb1_transmitting == 1);
    MOV R0, #keyModifiers
    MOV A, @R0
    JZ L0118                ;                   if (key_modifiers == 0
    LJMP L0024
L0118:
    MOV R0, #4Dh
    MOV A, @R0
    JZ L0119                ;                       and keys_down[0] == 0
    LJMP L0024
L0119:
    INC R0
    MOV A, @R0
    JZ L0120                ;                       and keys_down[1] == 0
    LJMP L0024
L0120:
    MOV R0, #4h
    MOVX A, @R0
    JZ L0121                ;                       and numlock_timer == 0
    LJMP L0024
L0121:
    INC R0
    MOVX A, @R0
    XRL A, #0CCh
    JZ L0122                ;                       and numlock_state == 0xCC)
    LJMP L0024
L0122:                                          ;                   {
    DEC R0
    MOV A, #0FFh
    MOVX @R0, A             ;                       numlock_timer = 0xFF;
    INC R0
    MOV A, #88h
    MOVX @R0, A             ;                       numlock_state = 0x88;
    LJMP L0024
                            ;                   }
L0046:                                          ;               } else /*kb_mode != 0x5A*/
    MOV R0, #44h
    MOV A, @R0
    CJNE A, #80h, L0047     ;               if (after_macro == 0x80
    MOV R0, #keyModifiers
    MOV A, @R0
    JNZ L0047               ;                   and key_modifiers == 0
    MOV R0, #4Dh
    MOV A, @R0
    JNZ L0047               ;                   and keys_down[0] == 0)
    MOV R0, #44h            ;               {
    MOV @R0, A              ;                   after_macro = 0;
    LJMP L0024
L0047:                                          ;               } else {
    CLR A
    MOV R0, #4Ah
    MOV @R0, A
L0054:                                          ;                   for (keydown_index = 0; keydown_index < 6 and keys_down[keydown_index]; ) {
    MOV R0, #4Ah
    MOV A, @R0
    CLR C
    SUBB A, #6h
    JC L0048
    LJMP L0024
L0048:
    LCALL find_macro        ;                       if (find_macro(&keydown_index)) {
    JNC L0050
    LCALL play_macro        ;                           play_macro();
    MOV R0, #4Ah
    INC @R0                 ;                           ++keydown_index;
    MOV R0, #44h
    MOV @R0, #80h           ;                           after_macro = 0x80;
    SJMP L0052              ;                           continue;

L0050:                                          ;                       }
    CLR A
    MOV R0, #44h
    MOV @R0, A              ;                       after_macro = 0;
    CLR EA                  ;                       __uninterrupted {
    MOV DPTR, #EPINDEX
    INC A
    MOVX @DPTR, A           ;                           EPINDEX = 1;
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                           TXDAT = key_modifiers;
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;                           TXDAT = hid_reserved;
    CLR A
    MOV R0, #55h
    MOV @R0, A
L0081:                      ;   for (byte __volatile(v55) k = 0; j < 6 and not find_macro(keydown_index); ++keydown_index, ++k) {
    MOV R0, #4Ah
    MOV A, @R0
    CLR C
    SUBB A, #6h
    JNC L0080
    LCALL find_macro
    JC L0080
    MOV R0, #keyCode
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                               TXDAT = keycode;
    MOV R0, #4Ah
    INC @R0
    MOV R0, #55h
    INC @R0
    SJMP L0081              ;                           }

L0080:                      ;                           for (; k < 6; ++k) {
    MOV R0, #55h
    MOV A, @R0
    CLR C
    SUBB A, #6h
    JNC L0082

    MOV DPTR, #TXDAT
    CLR A
    MOVX @DPTR, A           ;                               TXDAT = 0;
    INC @R0
    SJMP L0080              ;           }

L0082:
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;                           usb1_transmitting = 1;
    MOV DPTR, #TXCNT
    MOV A, #8h
    MOVX @DPTR, A           ;                           TXCON = 8;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;                           EPINDEX = 0;
    SETB ENABLE_ANY                 ;                       }
L0083:                                          ;                       do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0083                ;                       } while (usb1_transmitting == 1);
L0052:
    MOV R0, #4Ah
    MOV A, @R0
    CLR C
    SUBB A, #6h
    JC L0053
    LJMP L0054

L0053:
    MOV A, @R0
    ADD A, #4Dh
    MOV R0, A
    MOV A, @R0
    JZ L0024
    LJMP L0054              ;                   }
                            ;           }   }                
L0024:                                          ;       } // column_index == 0x12
    MOV R0, #46h
    MOV A, @R0
    JZ cleanUp                ;       if (media_report_ready) {
    CLR EA                  ;           __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #2h
    MOVX @DPTR, A           ;               EPINDEX = 2;
    CLR A
    MOV R0, #53h
    MOV @R0, A
L0026:                                          ;               for (byte __volatile(v53) i = 0; i != 2; ++i) {
    MOV R0, #53h
    MOV A, @R0
    ADD A, #48h
    MOV R0, A
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                   TXDAT = hid_report2[i];
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    CJNE A, #2h, L0026      ;               }
    MOV R0, #45h
    MOV @R0, #1h            ;               usb2_transmitting = 1;
    MOV R0, #53h
    MOV A, @R0
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;               TXCNT = i; // 2
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;               EPINDEX = 0;
    SETB ENABLE_ANY                 ;           }
L0027:                                          ;           do {
    MOV R0, #45h
    MOV A, @R0
    XRL A, #1h
    JZ L0027                ;           } while (usb2_transmitting == 1);
    CLR A
    MOV R0, #46h
    MOV @R0, A              ;           media_report_ready = 0;
cleanUp:                                          ;       }
    MOV R0, #colIndex
    MOV A, @R0
    CJNE A, #NCOLUMNS, pkRetn     ;       if (column_index == sizeof(key_matrix)) {
    CLR A
    MOV R0, #4Ah
    MOV @R0, A              ;           keydown_index = 0;
    MOV R6, A
    MOV R7, #8h
    MOV R5, A
    MOV R3, A
    MOV R2, #0h
    MOV R1, #4Bh
    LCALL memset            ;           memset(hid_report, 8, 0);
    CLR A
    MOV R0, #normalKey
    MOV @R0, A              ;           normal_key = false;
    DEC R0
    MOV @R0, A              ;           phantom = 0;
pkRetn:                                          ;   }   }
    RET                     ;}


; Strobe one column bit, and read the matrix input, which is a bit array of the pressed keys on this column
read_column:                                    ;byte __register(R7) read_column(byte __register(R7) index) {
    MOV A, R7		; get the current column scan mask from col_scan_tab
    MOV B, #3h
    MUL AB
    
    ADD A, #LOW(COL_SCAN_TAB) 
    ;#7Ch		; weird way of moving address 187Ch into DPTR
    MOV DPL, A
    CLR A
    ADDC A, #HIGH(COL_SCAN_TAB)
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    MOV P1, A               ;   P1 = matrix_mask[index][0];
    MOV A, R7
    MOV B, #3h
    MUL AB
    ADD A, #LOW(COL_SCAN_TAB)+1
    MOV DPL, A
    CLR A
    ADDC A, #HIGH(COL_SCAN_TAB)
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    MOV P2, A               ;   P2 = matrix_mask[index][1];
    MOV A, R7
    MOV B, #3h
    MUL AB
    ADD A, #LOW(COL_SCAN_TAB)+2
    MOV DPL, A
    CLR A
    ADDC A, #HIGH(COL_SCAN_TAB)
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    ANL P3, A               ;   P3 &= matrix_mask[index][2];
    MOV R7, #0Ah
    LCALL micro_delay       ;   micro_delay(10); // 10
    MOV R0, #colTemp
    MOV @R0, P0
    MOV A, @R0
    CPL A
    MOV @R0, A              ;   new_column_value = ~P0;
    MOV P1, #0FFh           ;   P1 = 0xFF;
    MOV P2, #0FFh           ;   P2 = 0xFF;
    ORL P3, #18h            ;   P3 |= 0x18;
    MOV A, @R0
    MOV R7, A               ;   return new_column_value;
    RET                     ;}


;;; By varying the loop limits at 089B and 08A7, we can change how often the keyboard is polled.
scan_delay:                                     ;void scan_delay() {
    MOV R6, #POLL_INTERVAL_250
    MOV A, R6
    JZ scan_delay__skip     ;   for (byte __register(R6) i = 0; i != 0; --i) {
scan_delay__loop:
    MOV R7, #0FAh
    LCALL micro_delay       ;       micro_delay(250);
    DJNZ R6, scan_delay__loop
scan_delay__skip:                               ;   }
    MOV R7, #POLL_INTERVAL_UNITS
    LJMP micro_delay        ;   micro_delay(70);
                            ;}

do_delay:                                       ;void do_delay() {
    MOV R0, #4h
    MOVX A, @R0
    MOV R7, A
    JNZ L0018               ;   if (numlock_timer == 0
    INC R0
    MOVX A, @R0
    CJNE A, #88h, L0018     ;       and numlock_state == 0x88)
    MOV A, #0BBh            ;   {
    MOVX @R0, A             ;       numlock_state = 0xBB;
    RET                     ;       return;

L0018:                                          ;   }
    MOV A, R7
    CLR C
    SUBB A, #0h
    JC L0019                ;   if (numlock_timer >= 0 // always??
    MOV R0, #5h
    MOVX A, @R0
    CJNE A, #88h, L0019     ;       and numlock_state == 0x88)
    DEC R0                  ;   {
    MOVX A, @R0
    DEC A
    MOVX @R0, A             ;       --numlock_timer;
    NOP
    LCALL micro_delay_750   ;       micro_delay_750();
L0019:                                          ;   }
    RET                     ;}



DO_TIMER0:                                      ;void __interrupt timer0() {
    PUSH ACC
    PUSH PSW
    MOV PSW, #8h            ;   // use register bank 1
    MOV R0, #1h
    MOVX A, @R0
    MOV 0E1h, A             ;   WDTCR = wdtcr; // Watch-dog Timer
    CLR TR0
    DEC R0
    MOVX A, @R0
    JZ L0232                ;   if (delay_count != 0) {
    MOVX A, @R0
    DEC A
    MOVX @R0, A             ;       --delay_count;
    MOV TL0, #18h
    MOV TH0, #0FCh          ;       set_timer0(-1000);
    SETB TR0
L0232:                                          ;   }
    POP PSW
    POP ACC
    RETI                    ;}

micro_delay_1000:                               ;void micro_delay_1000() {…}
    MOV R7, #0FAh
    LCALL micro_delay
micro_delay_750:                                ;void micro_delay_750() {…}
    MOV R7, #0FAh
    LCALL micro_delay
micro_delay_500:                                ;void micro_delay_500() {
    MOV R7, #250
    LCALL micro_delay       ;   micro_delay(250);
    MOV R7, #250           ;   micro_delay(250);
                            ;}
micro_delay:                                    ;void micro_delay(byte __register(R7) iters) {
    MOV A, R7               ;   for (; iters >= 1; --iters) { // 1 clock
    SETB C                  ;                                 // 1 clock
    SUBB A, #0h             ;                                 // 2 clocks
    JC L0017                ;                                 // 3 clocks
    NOP                     ;                                 // 1 clock
    DEC R7                  ;                                 // 3 clock
    SJMP micro_delay        ;   }                             // 3 clocks, total 14 = 1.1(6) microseconds per iter
L0017:
    RET                     ;}

upd_leds:                                       ;void upd_leds() {
    MOV C, 1h
    CPL C
    MOV P3.6, C             ;   P3./CAPS = !ledState.CAPS;
    MOV C, 2h
    CPL C
    MOV P3.7, C             ;   P3./SCROLL = !ledState.SCROLL;
    MOV R0, #kbMode
    MOV A, @R0
    CJNE A, #5Ah, L0148     ;   if (kb_mode == 0x5A) {
    SETB P4.0               ;       P4.0 = true;
    RET                     ;   } else {
L0148:
    CLR 0E8h                ;       P4.0 = false;
    RET                     ;}  }



delay:                                          ;void delay(byte __register(R7) ms) {
    CLR TR0
    MOV R0, #0h
    MOV A, R7
    MOVX @R0, A             ;   delay_count = param;
    MOV TL0, #18h
    MOV TH0, #0FCh          ;   set_timer0(-1000);
    SETB TR0
L0230:                                          ;   do {
    MOV R0, #0h
    MOVX A, @R0
    JNZ L0230               ;   } while (delay_count != 0);
    RET                     ;}

    
; Activate OS numlock if internal numlock is on and OS numlock off?
; Simulate press and release of num key
numlock_on:                                     ;void numlock_on() {
    MOV R0, #5h
    MOVX A, @R0
    XRL A, #0EAh
    JNZ L0123               ;   if (numlock_state == 0xEA
    NOP
    NOP
    NOP
    JB numLock, L0123            ;       and not ledState.1)    // OS NumLock if OFF
                            ;   {
    CLR EA                  ;       __uninterrupted {       // Send NumLock keypress
    MOV DPTR, #EPINDEX
    INC A
    MOVX @DPTR, A           ;           EPINDEX = 1;
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;           TXDAT = key_modifiers;
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV A, #53h
    MOVX @DPTR, A           ;           TXDAT = 0x53; // NumLock
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;           usb1_transmitting = 1;
    MOV DPTR, #TXCNT
    MOV A, #8h
    MOVX @DPTR, A           ;           TXCNT = 8;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    SETB ENABLE_ANY                 ;       }
L0124:                                          ;       do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0124                ;       } while (usb1_transmitting == 1);
    LCALL micro_delay_1000  ;       micro_delay_1000();
    CLR EA                  ;       __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #1h
    MOVX @DPTR, A           ;           EPINDEX = 1;
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;           TXDAT = key_modifiers;
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;           usb1_transmitting = 1;
    MOV DPTR, #TXCNT
    MOV A, #8h
    MOVX @DPTR, A           ;           TXCNT = 8;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    SETB ENABLE_ANY                 ;       }
L0125:                                          ;       do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0125                ;       } while (usb1_transmitting == 1);
    LCALL micro_delay_500   ;       micro_delay_500();
    MOV R0, #5h
    MOV A, #0CCh
    MOVX @R0, A             ;       numlock_state = 0xCC;
L0123:                                          ;   }
    RET                     ;}


    

numlock_off:                                    ;void numlock_off() {
    MOV R0, #5h
    MOVX A, @R0
    XRL A, #0BBh
    JZ L0010                ;   if (numlock_state == 0xBB) {
    LJMP L0011

L0010:
    CLR EA                  ;       __uninterrupted {
    MOV DPTR, #EPINDEX
    INC A
    MOVX @DPTR, A           ;           EPINDEX = 1;
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;           TXDAT = key_modifiers;
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV R0, #4Dh
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[0];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[1];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[2];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[3];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[4];
    MOV A, #53h
    MOVX @DPTR, A           ;           TXDAT = 0x53; // Num
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;           usb1_transmitting = 1;
    MOV DPTR, #TXCNT
    MOV A, #8h
    MOVX @DPTR, A           ;           TXCNT = 8;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    SETB ENABLE_ANY                 ;       }
L0012:                                          ;       do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0012                ;       } while (usb1_transmitting == 1);
    LCALL micro_delay_1000  ;       micro_delay_1000();
    CLR EA                  ;       __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #1h
    MOVX @DPTR, A           ;           EPINDEX = 1;
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;           TXDAT = key_modifiers;
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV R0, #4Dh
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[0];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[1];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[2];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[3];
    INC R0
    MOV A, @R0
    MOVX @DPTR, A           ;           TXDAT = keys_down[4];
    CLR A
    MOVX @DPTR, A           ;           TXDAT = 0;
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;           usb1_transmitting = 1;
    MOV DPTR, #TXCNT
    MOV A, #8h
    MOVX @DPTR, A           ;           TXCNT = 8;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    SETB ENABLE_ANY                 ;       }
L0014:                                          ;       do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0014                ;       } while (usb1_transmitting == 1);
    CLR A
    MOV R0, #5h
    MOVX @R0, A             ;       numlock_state = 0;
    LCALL micro_delay_500   ;       micro_delay_500();
L0011:                                          ;   }
    RET                     ;}
    
    
trigger_numlock:                                ;void trigger_numlock() {
	
    MOV R0, #5h
    MOVX A, @R0
    JNZ L0176               ;   if (numlock_state == 0
    MOV R0, #normalKey
    MOV A, @R0
    CJNE A, #1h, L0176      ;       and normal_key)
    MOV R0, #5h             ;   {
    MOV A, #0EAh
    MOVX @R0, A             ;       numlock_state = 0xEA;
L0176:                                          ;   }
    RET                     ;}

    
    
    
check_phantom:                                          ;byte __register(R7) f0152() {
    LCALL two_bits_set
    JNC L0211               ;   if (not two_bits_set()) return 0;
    LCALL same_column_value
    JNC L0211               ;   if (not same_column_value()) return 0;
    MOV R7, #0h
    RET                     ;   return 0;

L0211:
    MOV R7, #0h
    RET                     ;}


two_bits_set:                                   ;bool __register(C) two_bits_set() {
    CLR A
    MOV R0, #53h
    MOV @R0, A
    MOV R0, #56h
    MOV @R0, A              ;   v56 = 0;
L0220:                                          ;   for (byte __volatile(v53) i = 0; i < 8; ++i) {
    MOV R0, #53h
    MOV A, @R0
    MOV R7, A
    CLR C
    SUBB A, #8h
    JNC L0216
    MOV A, #80h
    MOV R6, #0h
    XCH A, R0
    MOV A, R7
    XCH A, R0
    INC R0
    SJMP L0217

L0218:
    XCH A, R6
    MOV C, ACC.7
    RRC A
    XCH A, R6
    RRC A
L0217:
    DJNZ R0, L0218

    MOV R7, A
    MOV R0, #colValue
    MOV A, @R0
    MOV R5, A
    MOV A, R7
    ANL A, R5
    JZ L0219                ;       if (column_value & 0x80 >> i) {
    MOV R0, #56h
    INC @R0                 ;           ++v56;
    MOV A, @R0
    CJNE A, #2h, L0219      ;           if (v56 == 2)
    SETB C
    RET                     ;               return true;

L0219:                                          ;       }
    MOV R0, #53h
    INC @R0
    SJMP L0220              ;   }

L0216:
    CLR C                   ;   return false;
    RET                     ;}

                            ;// Output into ports P1, P2, ANDed into P3 from read_column()
                            ;static const byte matrix_mask[][3] = {



same_column_value:                              ;bool __register(C) same_column_value() {
    MOV R0, #colIndex
    MOV A, @R0
    INC A
    MOV R7, A					; R7 = colindex+1
    MOV R0, #53h
    MOV @R0, A
    CJNE R7, #NCOLUMNS, L0213
    CLR A
    MOV @R0, A
L0213:                                          ;   for (__volatile(v53) i = (column_index + 1) % sizeof(key_matrix); i != column_index; i = (i + 1) % sizeof(key_matrix)) { // Complicated expressions in pseudo-C; basically “roll over to 0 until original value”
    MOV R0, #53h
    MOV A, @R0
    MOV R7, A
    MOV R0, #colIndex
    XRL A, @R0
    JZ L0214
    LCALL read_column
    MOV R0, #56h
    MOV A, R7
    MOV @R0, A              ;       v56 = read_column(v53);
    MOV R0, #colValue
    MOV A, @R0
    XRL A, R7
    JNZ L0215               ;       if (column_value == v56) {
    SETB C                  ;           return true;
    RET
L0215:                                          ;       }
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    CJNE A, #NCOLUMNS, L0213
    CLR A
    MOV @R0, A
    SJMP L0213

L0214:                                          ;   }
    CLR C                   ;   return false;
    RET                     ;}

                            ;// http://geekhack.org/index.php?topic=40888.0
                            ;// addwyn: Truly Ergonomic Shift-F12-F12 locks the NumLock key...
process_shift_f12:                              ;void process_shift_f12() {
    MOV R0, #keyModifiers
    MOV A, @R0
    MOV R7, A
    CJNE A, #2h, L0144      ;   if (key_modifiers != [LShift]
    MOV R0, #4Eh
    MOV A, @R0
    JZ L0145                ;       or keys_down[1] != 0)
L0144:                                          ;   {
    CLR A
    MOV R0, #shiftF12Count
    MOV @R0, A              ;       shift_f12_count = 0;
    RET                     ;       return;

L0145:                                          ;   }
    MOV A, R7
    CJNE A, #2h, L0146      ;   if (key_modifiers == [LShift]
    MOV R0, #4Dh
    MOV A, @R0
    CJNE A, #45h, L0146     ;       and keys_down[0] == 0x45 // F12
    MOV R0, #shiftF12Count
    INC @R0
    MOV A, @R0
    CJNE A, #2h, L0146      ;       and ++shift_f12_count == 2)
    DEC R0                  ;   {
    MOV A, @R0
    CPL A
    MOV @R0, A              ;       kb_mode = ~kb_mode;
    CLR A
    INC R0
    MOV @R0, A              ;       shift_f12_count = 0;
    LCALL upd_leds          ;       upd_leds();
L0146:                                          ;   }
    RET                     ;}
    
