DO_USB:                                         ;void __interrupt usb_intr() {
    PUSH ACC
    PUSH B
    PUSH DPH
    PUSH DPL
    PUSH PSW
    MOV PSW, #18h           ;   // use register bank 3
    MOV R0, #1h
    MOVX A, @R0
    MOV 0E1h, A             ;   WDTCR = wdtcr; // Watch-dog timer
    LCALL DO_USB_2          ;   do_usb_2();
    POP PSW
    POP DPL
    POP DPH
    POP B
    POP ACC
    RETI                    ;}

get_interface:                                  ;void get_interface() {
    MOV R0, #5Ch
    CLR A
    MOVX @R0, A
    INC R0
    INC A
    MOVX @R0, A             ;   tx_rx_count = 1;
    MOV R0, #1Bh
    MOVX A, @R0             ;   switch (LOBYTE(request.wIndex)) {
    DEC A
    JZ L0398                ;       // case 1
    INC A
    JNZ L0399               ;   case 0: // default over
L0398:                                          ;   case 1:
    CLR A
    MOV R0, #17h
    MOVX @R0, A             ;       report[0] = 0;
    RET                     ;       return;

L0399:                                          ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;   EPCON.RXSTL = EPCON.TXSTL = 0;
    RET                     ;}  }
get_descriptor:                                 ;void get_descriptor() {
    CLR A
    MOV R0, #64h
    MOVX @R0, A             ;   X64 = 0;
    MOV R0, #1Eh
    MOVX A, @R0
    MOV R0, #5Fh
    MOVX @R0, A
    MOV R0, #1Dh
    MOVX A, @R0
    MOV R0, #60h
    MOVX @R0, A             ;   word requested_size = request.wLength;
    MOV R0, #1Ah
    MOVX A, @R0             ;   switch (HIBYTE(request.wValue)) {
    ADD A, #0FEh
    JZ L0362                ;       // case 2
    DEC A
    JZ L0363                ;       // case 3
    ADD A, #0E2h
    JNZ L0364
    LJMP L0365              ;       // case 0x21

L0364:
    DEC A
    JNZ L0374
    LJMP L0375              ;       // case 0x22

L0374:
    ADD A, #21h
    JZ L0378                ;       // case 1
    LJMP L0379              ;       // default

L0378:                                          ;   case 1: // Device descriptor
    MOV R3, #0FFh
    MOV R2, #(HIGH DEVICE_DESCRIPTOR)
    MOV R1, #(LOW DEVICE_DESCRIPTOR)
    MOV R0, #57h
    MOV A, R3
    MOVX @R0, A             ;       transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, R2
    MOVX @R0, A
    INC R0
    MOV A, R1
    MOVX @R0, A             ;       to_transmit = &device_descriptor;  // base address
    LJMP L0380              ;       X65 = device_descriptor.bLength; break; // byte count

L0362:                                          ;   case 2: // Configuration descriptor
    MOV R3, #0FFh
    MOV R2, #HIGH(CONFIGURATION_DESCRIPTOR)
    MOV R1, #LOW(CONFIGURATION_DESCRIPTOR)
    MOV R0, #57h
    MOV A, R3
    MOVX @R0, A             ;       transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, R2
    MOVX @R0, A
    INC R0
    MOV A, R1
    MOVX @R0, A             ;       to_transmit = &configuration_descriptor;
    MOV DPTR, #0002h
    LCALL memread
    LJMP L0381              ;       X65 = configuration_descriptor.wTotalLength; break; // memread(0xFF, 2, 0x0DE5)

L0363:                                          ;   case 3: // String descriptor
    MOV R0, #19h
    MOVX A, @R0             ;       switch (LOBYTE(request.wValue)) {
    DEC A
    JZ L0382                ;           // case 1
    DEC A
    JZ L0383                ;           // case 2
    DEC A
    JZ L0384                ;           // case 3
    ADD A, #3h
    JNZ L0385               ;       case 0: // String languages
    MOV R0, #57h
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(LANGUAGE)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(LANGUAGE)
    MOVX @R0, A             ;           to_transmit = &string_languages;
    SJMP L0386

L0382:                                          ;       case 1: // Manufacturer name
    MOV DPTR, #HAS_MANUFACTURER
    CLR A
    MOVC A, @A+DPTR
    JZ L0385                ;           if (device_descriptor.iManufacturer == 0) /*false*/ { EPCON.RXSTL = EPCON.TXSTL = 1; break; }
    MOV R0, #57h
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(MANUFACTURER_NAME)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(MANUFACTURER_NAME)
    MOVX @R0, A             ;           to_transmit = &manufacturer_name;
    SJMP L0386              ;           break;

L0383:                                          ;       case 2: // Product name
    MOV DPTR, #HAS_PRODUCT
    CLR A
    MOVC A, @A+DPTR
    JZ L0388                ;           if (device_descriptor.iProduct != 0) { // true
    MOV R0, #57h
    MOV A, #0FFh
    MOVX @R0, A             ;               transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(PRODUCT_NAME)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(PRODUCT_NAME)
    MOVX @R0, A             ;               to_transmit = &product_name;
    SJMP L0386              ;               break;

L0388:                                          ;           }
    SJMP L0385              ;           EPCON.RXSTL = EPCON.TXSTL = 1; break;

L0384:                                          ;       case 3: // Serial number
    MOV DPTR, #HAS_STRING
    CLR A
    MOVC A, @A+DPTR
    JZ L0387                ;           if (device_descriptor.iSerialNumber != 0) { // false
    MOV R0, #57h
    MOV A, #0FFh
    MOVX @R0, A             ;               transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(SERIAL_NUMBER)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(SERIAL_NUMBER)
    MOVX @R0, A             ;               to_transmit = &serial_number;
    SJMP L0386              ;               break;

L0387:                                          ;           }
    SJMP L0385              ;           EPCON.RXSTL = EPCON.TXSTL = 1; break;

L0385:                                          ;       default: // Invalid
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;           EPCON.RXSTL = EPCON.TXSTL = 1;
L0386:                                          ;       }
    MOV R0, #57h
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R1, A
L0380:
    LCALL byte_read
    SJMP L0381              ;       X65 = *to_transmit; break; // byte_read(transmit_addr_mode, to_transmit)

L0365:                                          ;   case 0x21: // HID descriptor
    MOV R0, #1Bh
    MOVX A, @R0
    MOV R0, #57h
    JZ L0366                ;       if (LOBYTE(request.wIndex) != 0) {
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(HID_DESCRIPTOR1)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(HID_DESCRIPTOR1)
    MOVX @R0, A             ;           to_transmit = &i1_hid_descriptor;
    SJMP L0367

L0366:                                          ;       } else {
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(HID_DESCRIPTOR0)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(HID_DESCRIPTOR0)
    MOVX @R0, A             ;           to_transmit = &i0_hid_descriptor;
L0367:                                          ;       }
    MOV R0, #57h
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    LCALL byte_read
L0381:
    MOV R0, #65h
    MOVX @R0, A             ;       X65 = *to_transmit; // byte_read(transmit_addr_mode, to_transmit);
    SJMP L0369              ;       break;

L0375:                                          ;   case 0x22: // Report Descriptor
    MOV R0, #1Bh
    MOVX A, @R0
    MOV R0, #57h
    JZ L0376                ;       if (LOBYTE(report.wIndex) != 0) {
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(REPORT_DESCRIPTOR1)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(REPORT_DESCRIPTOR1)
    MOVX @R0, A             ;           to_transmit = &i1_report_descriptor;
    MOV DPTR, #HID_DESCRIPTOR1_LEN        ;           DPTR = &i1_hid_descriptor.wDescriptorLength;
    SJMP L0377

L0376:                                          ;       } else {
    MOV A, #0FFh
    MOVX @R0, A             ;           transmit_addr_mode = CMEM_16;
    INC R0
    MOV A, #HIGH(REPORT_DESCRIPTOR0)
    MOVX @R0, A
    INC R0
    MOV A, #LOW(REPORT_DESCRIPTOR0)
    MOVX @R0, A             ;           to_transmit = &i0_report_descriptor;
    MOV DPTR, #HID_DESCRIPTOR0_LEN        ;           DPTR = &i0_hid_descriptor.wDescriptorLength;
L0377:                                          ;       }
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #65h
    MOVX @R0, A
    INC DPTR
    CLR A
    MOVC A, @A+DPTR
    DEC R0
    MOVX @R0, A             ;       Xw64 = *(__little_endian word*)DPTR;
    SJMP L0369              ;       break;

L0379:                                          ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = 1;
L0369:                                          ;   }
    MOV R0, #64h
    MOVX A, @R0
    MOV R6, A
    INC R0
    MOVX A, @R0
    MOV R7, A
    MOV R0, #5Fh
    MOVX A, @R0
    MOV R4, A
    INC R0
    MOVX A, @R0
    MOV R5, A
    SETB C
    SUBB A, R7
    MOV A, R4
    SUBB A, R6
    JC L0370                ;   if (requested_size < Xw64 + 1) {
    MOV R0, #64h
    MOVX A, @R0
    MOV R7, A
    INC R0
    MOVX A, @R0
    MOV R0, #5Ch
    XCH A, R7
    MOVX @R0, A
    INC R0
    MOV A, R7
    MOVX @R0, A             ;       tx_rx_count = Xw64;
    RET

L0370:                                          ;   } else {
    MOV R0, #5Ch
    MOV A, R4
    MOVX @R0, A
    INC R0
    MOV A, R5
    MOVX @R0, A             ;       tx_rx_count = requested_size;
    RET                     ;}  }                       // tx_rx_count = max(requested_size, Xw64); // wtf

    

do_usb_2:                                       ;void do_usb_2() {
    MOV DPTR, #UPCON
    MOVX A, @DPTR
    MOV R0, #63h
    MOVX @R0, A             ;   X63 = UPCON;
    MOVX A, @R0
    MOV R7, A
    ANL A, #0Fh
    JNZ L0240               ;   if (X63 & 0x0F != 0) // URST (USB Reset) | URSM (USB Resume) | USUS (USB Suspend) | 0x08
    LJMP L0241              ;   {
L0240:
    MOV A, R7
    JNB ACC.0, L0324        ;       if (X63.USUS) {
    MOVX A, @R0
    ANL A, #0F0h
    MOVX @R0, A             ;           X63 &= 0xF0; // CONEN | URWU | 0x50
    ORL A, #1h
    MOVX @DPTR, A           ;           UPCON = X63 | USUS; // 0x01 USB Suspend Flag
    MOVX A, @DPTR
    MOVX @R0, A             ;           X63 = UPCON;
    MOVX A, @R0
    ANL A, #0Fh
    JZ L0325                ;           if (X63 & 0x0F != 0)
    LJMP L0245              ;               return;

L0325:
    LCALL leds_off          ;           leds_off();
    MOV R0, #14h
    MOVX A, @R0
    CJNE A, #1h, L0327      ;           if (remote_wakeup == 1) {
    CLR A
    MOV P1, A               ;               P1 = 0;
    MOV P2, A               ;               P2 = 0;
    ANL P3, #0E7h           ;               P3 &= 0xE7; // xxx00xxx
    MOV 0D5h, #0FFh         ;               KBPATN = 0xFF;
    MOV 0D6h, A             ;               KBCON = 0;
    MOV 0D7h, #0FFh         ;               KBMASK = 0xFF;
L0327:                                          ;           }
    ORL PCON, #2h           ;           PCON |= PD; // Power-Down
    MOV R7, #1h
    LCALL delay             ;           delay(1);
    MOV R0, #14h
    MOVX A, @R0
    CJNE A, #1h, L0328      ;           if (remote_wakeup == 1) {
    MOV A, 0D7h
    JNZ L0329               ;               if (KBMASK == 0) {
    MOV DPTR, #UPCON
    MOVX A, @DPTR
    ORL A, #20h
    MOVX @DPTR, A           ;                   UPCON |= URWU; // USB Remote Wake-Up Trigger
    SJMP L0330
L0329:                                          ;               } else {
    CLR A
    MOV 0D7h, A             ;                   KBMASK = 0;
L0330:                                          ;               }
    MOV P1, #0FFh           ;               P1 = 0xFF;
    MOV P2, #0FFh           ;               P2 = 0xFF;
    ORL P3, #18h            ;               P3 |= 0x18; // xxx11xxx
L0328:                                          ;           }
    MOV R0, #15h
    MOVX A, @R0
    XRL A, #1h
    JZ L0331                ;           if (configured != true)
    LJMP L0245              ;               return;
L0331:
    LJMP upd_leds           ;           upd_leds(); return;
L0324:                                          ;       }
    MOV R0, #63h
    MOVX A, @R0
    MOV R7, A               ;       R7 = X63;
    JNB ACC.2, L0332        ;       if (X63.URST) {
    ANL A, #0F0h
    MOVX @R0, A             ;           X63 &= 0xF0; // CONEN | URWU | 0x50
    ORL A, #4h
    MOV DPTR, #UPCON
    MOVX @DPTR, A           ;           UPCON = X63 | URST;
    LCALL init_vars         ;           init_vars();
    LJMP init_hw            ;           init_hw(); return;

L0332:                                          ;       }
    MOV R0, #63h
    MOVX A, @R0
    JB ACC.1, L0333         ;       if (X63.URSM) {
    LJMP L0245
L0333:
    ANL A, #0F0h
    MOVX @R0, A             ;           X63 &= 0xF0; // CONEN | URWU | 0x50
    ORL A, #2h
    MOV DPTR, #UPCON
    MOVX @DPTR, A           ;           UPCON = X63 | URSM;
                            ;       }
    RET                     ;       return;
L0241:                                          ;   }
    MOV DPTR, #UIFLG
    MOVX A, @DPTR
    MOV R0, #63h
    MOVX @R0, A
    MOVX A, @R0
    MOV R5, A               ;   R5 = X63 = A = UIFLG;
    JNB ACC.2, L0242        ;   if (X63.UTXD1) {
    MOV A, #4h
    MOVX @DPTR, A           ;       UIFLG = UTXD1;
    MOV A, #1h
    LCALL usb_transmit      ;       usb_transmit(1);
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JNZ L0244               ;       if (usb1_transmitting == 1)
    MOV @R0, A              ;           usb1_transmitting = 0;
    SJMP L0244              ;
L0242:                                          ;   } else
    MOV A, R5
    JNB ACC.4, L0246        ;   if (X63.UTXD2) {
    MOV DPTR, #UIFLG
    MOV A, #10h
    MOVX @DPTR, A           ;       UIFLG = UTXD2;
    MOV A, #2h
    LCALL usb_transmit      ;       usb_transmit(2);
    MOV R0, #45h
    MOV A, @R0
    XRL A, #1h
    JNZ L0244               ;       if (usb2_transmitting == 1)
    MOV @R0, A              ;           usb2_transmitting = 0;
    SJMP L0244
L0246:                                          ;   } else
    MOV R0, #63h
    MOVX A, @R0
    JNB ACC.1, L0247        ;   if (X63.URXD0) {
    MOV DPTR, #UIFLG
    MOV A, #2h
    MOVX @DPTR, A           ;       UIFLG = URXD0;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;       EPINDEX = 0;
    LCALL received_ep0      ;       received_ep0();
    SJMP L0244

L0247:                                          ;   } else
    MOV R0, #63h
    MOVX A, @R0
    JNB ACC.0, L0244        ;   if (X63.UTXD0) {
    MOV DPTR, #UIFLG
    MOV A, #1h
    MOVX @DPTR, A           ;       UIFLG = UTXD0;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;       EPINDEX = 0;
    LCALL do_transmit       ;       do_transmit();
L0244:                                          ;   }
    MOV R0, #63h
    MOVX A, @R0
    JNB ACC.7, L0245        ;   if (X63.SOFIF) {
    MOV DPTR, #UIFLG
    MOV A, #80h
    MOVX @DPTR, A           ;       UIFLG = SOFIF;
    MOV R0, #43h
    MOV A, @R0
    JZ L0245                ;       if (usb_intr_count)
    DEC @R0                 ;           --usb_intr_count;
L0245:                                          ;   }
    RET                     ;}


do_receive:                                     ;void do_receive() {
                            ;   byte __volatile(X64) count;
    MOV DPTR, #TXCON
    MOV A, #80h
    MOVX @DPTR, A           ;   TXCON = TXCLR;
    MOV DPTR, #RSTAT
    MOVX A, @DPTR
    ANL A, #30h
    JZ L0298                ;   if (RXSTAT.STOVW or RXSTAT.EDOVW) {
    MOV R0, #16h
    MOV A, #0F0h
    MOVX @R0, A             ;       request_state = 0xF0;
L0299:                                          ;       do {do {
    MOV DPTR, #RSTAT
    MOVX A, @DPTR
    JB ACC.5, L0299         ;           } while (RXSTAT.STOVW);
L0300:                                          ;           do {
    MOV DPTR, #RSTAT
    MOVX A, @DPTR
    JNB ACC.4, L0300        ;           } while (not RXSTAT.EDOVW);
    MOV DPTR, #RSTAT
    MOVX A, @DPTR
    ANL A, #0EFh
    MOVX @DPTR, A           ;           RXSTAT.EDOVW = false; // to read FIFO
    MOV DPTR, #UIFLG
    MOV A, #2h
    MOVX @DPTR, A           ;           UIFLG = URXD0;
    MOV DPTR, #RXCNT
    MOVX A, @DPTR
    MOV R0, #64h
    MOVX @R0, A             ;           count = RXCNT;
    MOV R3, #0FEh
    MOV R2, #0h
    MOV R1, #17h
    MOVX A, @R0
    MOV R5, A
    LCALL receive           ;           receive(0xFE, &request, count);
    MOV DPTR, #RSTAT
    MOVX A, @DPTR
    ANL A, #30h
    JNZ L0299               ;       } while (RXSTAT.STOVW or RXSTAT.EDOVW);
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ANL A, #3Fh
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = false;
    INC DPTR
    MOVX A, @DPTR
    ANL A, #0BFh
    MOVX @DPTR, A           ;       RXSTAT.RXSETUP = false;
    MOV R0, #64h
    MOVX A, @R0
    MOV R7, A
    MOV R0, #5Ch
    CLR A
    MOVX @R0, A
    INC R0
    MOV A, R7
    MOVX @R0, A             ;       tx_rx_count = count;
    SJMP L0302

L0298:                                          ;   } else {
    MOV R0, #16h
    MOVX A, @R0
    XRL A, #33h
    JNZ L0309               ;       if (request_state == 0x33) {
    MOV DPTR, #RXCNT
    MOVX A, @DPTR
    MOV R0, #64h
    MOVX @R0, A             ;           count = RXCNT;
    MOVX A, @R0
    MOV R7, A
    CLR C
    MOV R0, #5Dh
    MOVX A, @R0
    SUBB A, R7
    MOVX @R0, A
    DEC R0
    MOVX A, @R0
    SUBB A, #0h
    MOVX @R0, A             ;           tx_rx_count -= count;
    MOV R3, #0FEh
    MOV R2, #0h
    MOV R1, #17h
    MOV R0, #64h
    MOVX A, @R0
    MOV R5, A
    LCALL receive           ;           receive(XRAM_8, &request, count);
    MOV R0, #64h
    MOVX A, @R0
    MOV R7, A
    CJNE A, #40h, L0310     ;           if (count == 0x40) { // 64 bytes?
    LCALL isp_reprogram     ;               isp_reprogram(count);
    SJMP L0312

L0310:                                          ;           } else {
    MOV R0, #17h
    MOVX A, @R0
    MOV ledState, A              ;               ledState = request[0];
    LCALL upd_leds          ;               upd_leds();
L0312:                                          ;           }
    MOV R0, #5Dh
    MOVX A, @R0
    JNZ L0313
    DEC R0
    MOVX A, @R0
L0313:
    JNZ L0302               ;           if (tx_rx_count != 0) {
                            ;               RXCON.RXFFRC = true;
                            ;               return;
                            ;           }
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;           TXCNT = 0;
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;           request_state = 0xA5;
    SJMP L0302              ;           RXCON.RXFFRC = true; return;

L0309:                                          ;       }
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = true;
L0302:                                          ;   }
    MOV DPTR, #RXCON
    MOVX A, @DPTR
    ORL A, #10h
    MOVX @DPTR, A           ;   RXCON.RXFFRC = true;
    RET                     ;}

standard_request:                               ;void standard_request() {
    MOV R0, #18h
    MOVX A, @R0
    CJNE A, #0Dh, L0254
L0254:
    JC L0255                ;   switch (request.bRequest) {
    LJMP L0256
L0255:
    MOV DPTR, #JUMPTAB2
    MOV R0, A
    ADD A, R0
    ADD A, R0
    JMP @A+DPTR
JUMPTAB2:
    LJMP L0334
    LJMP L0344
    LJMP L0256
    LJMP L0352
    LJMP L0256
    LJMP L0359
    LJMP L0360
    LJMP L0256
    LJMP L0389
    LJMP L0390
    LJMP L0396
    LJMP L0400
    LJMP L0405

L0334:                                          ;   case 0: // GET_STATUS
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    LCALL get_status        ;       get_status();
    SJMP L0336              ;       do_transmit(); return;

L0344:                                          ;   case 1: // CLEAR_FEATURE
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    LCALL clear_feature     ;       clear_feature();
    SJMP L0346              ;       TXCNT = 0; return;

L0352:                                          ;   case 3: // SET_FEATURE
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    LCALL set_feature       ;       set_feature();
    SJMP L0346              ;       TXCNT = 0; return;

L0359:                                          ;   case 5: // SET_ADDRESS
    MOV R0, #16h
    MOV A, #55h
    MOVX @R0, A             ;       request_state = 0x55;
    MOV R0, #19h
    MOVX A, @R0
    MOV R0, #5Eh
    MOVX @R0, A             ;       usb_address = LOBYTE(request.wValue);
    SJMP L0346              ;       TXCNT = 0; return;

L0360:                                          ;   case 6: // GET_DESCRIPTOR
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    LCALL get_descriptor    ;       get_descriptor();
    SJMP L0336              ;       do_transmit(); return;

L0389:                                          ;   case 8: // GET_CONFIGURATION
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    MOV R0, #5Eh
    MOVX A, @R0
    MOV R0, #17h
    MOVX @R0, A             ;       report[0] = usb_configuration;
    MOV R0, #5Ch
    CLR A
    MOVX @R0, A
    INC R0
    INC A
    MOVX @R0, A             ;       tx_rx_count = 1;
    SJMP L0336              ;       do_transmit(); return;

L0390:                                          ;   case 9: // SET_CONFIGURATION
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    LCALL set_configuration ;       set_configuration();
L0346:
    MOV DPTR, #TXCNT
    CLR A
    MOVX @DPTR, A           ;       TXCNT = 0;
    RET                     ;       return;

L0400:                                          ;   case 0x0B: // SET_INTERFACE
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    LJMP set_interface      ;       set_interface(); return;

L0396:                                          ;   case 0x0A: // GET_INTERFACE
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    LCALL get_interface     ;       get_interface();
L0336:
    LJMP do_transmit        ;       do_transmit(); return;

L0405:                                          ;   case 0x0C: // SYNCH_FRAME
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    MOV DPTR, #TXCNT
    CLR A
    MOVX @DPTR, A           ;       TXCNT = 0;
    MOV R0, #5Ch
    MOVX @R0, A
    INC R0
    MOVX @R0, A             ;       tx_rx_count = 0;
    RET                     ;       return;

L0256:                                          ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = true;
    RET                     ;       return;
                            ;   }
                            ;}

vendor_request:                                 ;void vendor_request()
    MOV R0, #18h
    MOVX A, @R0
    DEC A
    JZ L0258                ;   switch (request.bRequest) {
    ADD A, #0FEh
    JZ L0259
    ADD A, #0FAh
    JZ L0260
    DEC A
    JZ L0261
    DEC A
    JZ L0262
    ADD A, #9h
    JZ L0263
    LJMP L0264

L0263:                                          ;   case 2: // Get unused variable v39
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    MOV R0, #idleRate
    SJMP L0265              ;       report[0] = v39;
                            ;       tx_rx_count = 1;
                            ;       do_transmit(); return;

L0259:                                          ;   case 3: // Get unused variable v3A
    MOV R0, #16h
    MOV A, #5Ah
    MOVX @R0, A             ;       request_state = 0x5A;
    MOV R0, #protocol
L0265:
    MOV A, @R0
    MOV R0, #17h
    MOVX @R0, A             ;       report[0] = v3A;
    MOV R0, #5Ch
    CLR A
    MOVX @R0, A
    INC R0
    INC A
    SJMP L0266              ;       tx_rx_count = 1;
                            ;       do_transmit(); return;

L0258:                                          ;   case 1: // Get macros
    MOV R0, #16h
    MOV A, #22h
    MOVX @R0, A             ;       request_state = 0x22;
                            ;       // The following looks like a convoluted way to assign X5C = X1E and X5D = X1D
                            ;       tx_rx_count = request.wLength;
    MOV R0, #1Eh            ;       //      R0 = 0x1E;
    MOVX A, @R0             ;       //      A = X1E;
    MOV R7, A               ;       //      R7 = X1E;
    MOV R0, #5Ch            ;       //      R0 = 0x5C;
    CLR A                   ;       //      A = 0;
    MOVX @R0, A             ;       //X5C = 0;
    INC R0                  ;       //      R0 = 0x5D;
    MOV A, R7               ;       //      A = X1E;
    MOVX @R0, A             ;       //X5D = X1E;
    MOV R1, #5Dh            ;       //      R1 = 0x5D;
    MOVX A, @R1             ;       //      A = X1E;
    MOV R0, A               ;       //      R0 = X1E;
    CLR A                   ;       //      A = 0;
    MOVX @R1, A             ;       //X5D = 0;
    MOV A, R0               ;       //      A = X1E;
    DEC R1                  ;       //      R1 = 0x5C;
    MOVX @R1, A             ;       //X5C = X1E;
    MOV R0, #1Dh            ;       //      R0 = 0x1D;
    MOVX A, @R0             ;       //      A = X1D;
    MOV R7, A               ;       //      R7 = X1D;
    MOV R0, #5Dh            ;       //      R0 = 0x5D;
    MOVX A, @R0             ;       //      A = X5D = 0;
    ADD A, R7               ;       //      A = X5D + X1D = X1D, no carry possible;
    MOVX @R0, A             ;       //X5D = X1D;
    DEC R0                  ;       //      R0 = 0x5C;
    MOVX A, @R0             ;       //      A = X5C = X1E;
    ADDC A, #0h             ;       //      A = X1E + (carry ? 1 : 0) = X1E;
L0266:
    MOVX @R0, A             ;       //X5C = X1E;
    LJMP do_transmit        ;       do_transmit(); return;

L0261:                                          ;   case 0x0A: // Set unused variable v39
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    MOV R0, #1Ah
    MOVX A, @R0
    MOV R0, #idleRate
    SJMP L0297              ;       v39 = HIBYTE(request.wValue);
                            ;       TXCNT = 0;
                            ;       return;

L0262:                                          ;   case 0x0B: // Set unused variable v3A
    MOV R0, #16h
    MOV A, #0A5h
    MOVX @R0, A             ;       request_state = 0xA5;
    MOV R0, #19h
    MOVX A, @R0
    MOV R0, #protocol
L0297:
    MOV @R0, A              ;       v3A = LOBYTE(request.wValue);
    MOV DPTR, #TXCNT
    CLR A
    MOVX @DPTR, A           ;       TXCNT = 0;
    RET                     ;       return;

L0260:                                          ;   case 9: // Set macros
    MOV R0, #16h
    MOV A, #33h
    MOVX @R0, A             ;       request_state = 0x33;
                            ;       tx_rx_count = request.wLength;
    MOV R0, #1Eh            ;       //      R0 = 0x1E;
    MOVX A, @R0             ;       //      A = X1E;
    MOV R7, A               ;       //      R7 = X1E;
    MOV R0, #5Ch            ;       //      R0 = 0x5C;
    CLR A                   ;       //      A = 0;
    MOVX @R0, A             ;       //X5C = 0;
    INC R0                  ;       //      R0 = 0x5D;
    MOV A, R7               ;       //      A = X1E;
    MOVX @R0, A             ;       //X5D = X1E;
    MOV R1, #5Dh            ;       //      R1 = 0x5D;
    MOVX A, @R1             ;       //      A = X5D = X1E;
    MOV R0, A               ;       //      R0 = X1E;
    CLR A                   ;       //      A = 0;
    MOVX @R1, A             ;       //X5D = 0;
    MOV A, R0               ;       //      A = X1E;
    DEC R1                  ;       //      R1 = 0x5C;
    MOVX @R1, A             ;       //X5C = X1E;
    MOV R0, #1Dh            ;       //      R0 = 0x1D;
    MOVX A, @R0             ;       //      A = X1D;
    MOV R7, A               ;       //      R7 = X1D;
    MOV R0, #5Dh            ;       //      R0 = 0x5D;
    MOVX A, @R0             ;       //      A = X5D = 0;
    ADD A, R7               ;       //      A = X1D; no carry
    MOVX @R0, A             ;       //X5D = X1D;
    DEC R0                  ;       //      R0 = 0x5C;
    MOVX A, @R0             ;       //      A = X5C = X1E;
    ADDC A, #0h             ;       //      A = X1E + no carry;
    MOVX @R0, A             ;       //X5C = X1E;
    RET                     ;       return;

L0264:                                          ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = true;
    RET                     ;   }
                            ;}

                            

do_transmit:                                    ;void do_transmit() {
    MOV R0, #16h
    MOVX A, @R0
    XRL A, #5Ah
    JNZ L0268               ;   if (request_state == 0x5A) {
    MOV R0, #5Bh
    MOVX A, @R0
    MOV R7, A
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R3, A
    SETB C
    SUBB A, R5
    MOV A, R2
    SUBB A, #0h
    MOV R0, #64h            ;       byte __volatile(X64) count;
    JC L0269                ;       if (tx_rx_count >= max_transmit + 1) {
    MOV A, R7
    MOVX @R0, A             ;           count = max_transmit;
    SJMP L0270

L0269:                                          ;       } else {
    MOV A, R3
    MOVX @R0, A             ;           count = LOBYTE(tx_rx_count);
L0270:                                          ;       }
    MOV R0, #57h
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    MOV R0, #64h
    MOVX A, @R0
    MOV R5, A
    LCALL transmit          ;       transmit(transmit_addr_mode, to_transmit, count);
    MOV R0, #64h
    MOVX A, @R0
    MOV R7, A
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;       TXCNT = count;
    MOV R6, #0h
    CLR C
    MOV R0, #5Dh
    MOVX A, @R0
    SUBB A, R7
    MOVX @R0, A
    DEC R0
    MOVX A, @R0
    SUBB A, R6
    MOVX @R0, A             ;       tx_rx_count -= count;
    MOV R0, #59h
    MOVX A, @R0
    ADD A, R7
    MOVX @R0, A
    DEC R0
    MOVX A, @R0
    ADDC A, R6
    MOVX @R0, A             ;       to_transmit += count;
    RET                     ;       return;
L0268:                                          ;   }
    MOV R0, #16h
    MOVX A, @R0
    XRL A, #22h
    JNZ L0278               ;   if (request_state == 0x22) {
    MOV R0, #5Bh
    MOVX A, @R0
    MOV R7, A
    MOV R5, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R3, A
    SETB C
    SUBB A, R5
    MOV A, R2
    SUBB A, #0h
    MOV R0, #64h            ;       byte __volatile(X64) count;
    JC L0279                ;       if (tx_rx_count >= max_transmit + 1) {
    MOV A, R7
    MOVX @R0, A             ;           count = max_transmit;
    SJMP L0280

L0279:                                          ;       } else {
    MOV A, R3
    MOVX @R0, A             ;           count = LOBYTE(tx_rx_count);
L0280:                                          ;       }
    MOV R0, #64h
    MOVX A, @R0
    CJNE A, #40h, L0281     ;       if (count == 0x40) {
    LCALL isp_read_block    ;           isp_read_block();
    SJMP L0283
L0281:                                          ;       } else
    MOV R0, #64h
    MOVX A, @R0
    JZ L0283                ;       if (count != 0) {
    MOV R0, #17h
    MOV A, ledState
    MOVX @R0, A             ;           report[0] = 0x20;
L0283:                                          ;       }
    MOV R3, #0FEh
    MOV R2, #0h
    MOV R1, #17h
    MOV R0, #64h
    MOVX A, @R0
    MOV R5, A
    LCALL transmit          ;       transmit(0xFE, &report, count);
    MOV R0, #64h
    MOVX A, @R0
    MOV R7, A
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;       TXCNT = count;
    CLR C
    MOV R0, #5Dh
    MOVX A, @R0
    SUBB A, R7
    MOVX @R0, A
    DEC R0
    MOVX A, @R0
    SUBB A, #0h
    MOVX @R0, A             ;       tx_rx_count -= count;
    RET                     ;       return;

L0278:                                          ;   }
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;   EPCON.RXSTL = EPCON.TXSTL = true;
    MOV R0, #16h
    MOVX A, @R0
    CJNE A, #55h, L0294     ;   if (request_state == 0x55) {
    MOV R0, #5Eh
    MOVX A, @R0
    MOV DPTR, #UADDR
    MOVX @DPTR, A           ;       UADDR = usb_address;
L0294:                                          ;   }
    MOV R0, #0Ah
    MOVX A, @R0
    CJNE A, #44h, L0295     ;   if (isp_state == 0x44
    JNB 0EBh, L0295         ;       and P4.3) {
    MOV R7, #68h
    LCALL set_ISPCR         ;       set_ISPCR(SBWS | SWRST | MISPF); // software reset, boot from ISP, Megawin
L0295:                                          ;   }
    RET                     ;}

byte_read:                                      ;byte __register(A) byte_read(R3 == 1,    byte* __register(R2:R1) Xptr)
                            ;               or  byte_read(R3 == 0,    byte* __register(R1) ptr)
                            ;               or  byte_read(R3 == 0xFE, byte* __register(R1) Xptr)
                            ;               or  byte_read(R3 == *,    byte* __register(R2:R1) Cptr)
                            ;{
    CJNE R3, #1h, L0371     ;   if (mode == 1) {
    MOV DPL, R1
    MOV DPH, R2
    MOVX A, @DPTR
    RET                     ;       return *Xptr;

L0371:                                          ;   } else
    JNC L0372               ;   if (mode < 1) {
    MOV A, @R1              ;       return *ptr;
    RET

L0372:                                          ;   } else
    CJNE R3, #0FEh, L0373   ;   if (mode == 0xFE) {
    MOVX A, @R1             ;       return *Xptr;
    RET

L0373:                                          ;   } else {
    MOV DPL, R1
    MOV DPH, R2
    CLR A
    MOVC A, @A+DPTR         ;       return *Cptr;
    RET                     ;}  }

memread:                                        ;byte __register(A) memread(R3 == 1,  byte* __register(DPH:DPL) Xbase16, word __register(R2:R1) offset16)
                            ;                   or   (R3 == 0,    byte* __register(DPL)     base8,   byte __register(R1) offset8)
                            ;                   or   (R3 == 0xFE, byte* __register(DPL)     Xbase8,  byte __register(R1) offset8)
                            ;                   or   (R3 == *,    byte* __register(DPH:DPL) Cbase16, byte __register(R2:R1) offset16)
                            ;{
    CJNE R3, #1h, L0275     ;   if (mode == 1) {
    MOV A, DPL
    ADD A, R1
    MOV DPL, A
    MOV A, DPH
    ADDC A, R2
    MOV DPH, A
    MOVX A, @DPTR
    RET                     ;       return Xbase16[offset16];

L0275:                                          ;   }
    JNC L0276               ;   else if (mode < 1) {
    MOV A, R1
    ADD A, DPL
    MOV R0, A
    MOV A, @R0              ;       return base8[offset8];
    RET

L0276:                                          ;   }
    CJNE R3, #0FEh, L0277   ;   else if (mode == 0xFE) {
    MOV A, R1
    ADD A, DPL
    MOV R0, A
    MOVX A, @R0             ;       return Xbase8[offset8];
    RET

L0277:                                          ;   } else {
    MOV A, DPL
    ADD A, R1
    MOV DPL, A
    MOV A, DPH
    ADDC A, R2
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR         ;       return Cbase16[offset16]
    RET                     ;}  }


set_configuration:                              ;void set_configuration() {
    MOV R0, #19h
    MOVX A, @R0
    MOV R0, #5Eh
    MOVX @R0, A             ;   usb_configuration = LOBYTE(request.wValue);
    JZ L0392                ;   if (LOBYTE(request.wValue) != 0) {
    MOV R7, #1h
L0393:                                          ;       for (byte __register(R7) i = 1; i != 6; ++i) {
    MOV DPTR, #EPINDEX
    MOV A, R7
    MOVX @DPTR, A           ;           EPINDEX = i;
    MOV DPTR, #EPCON
    MOV A, #5h
    MOVX @DPTR, A           ;           EPCON = RXEPEN | TXEPEN;
    MOV DPTR, #RXCON
    MOV A, #80h
    MOVX @DPTR, A           ;           RXCON = RXCLR;
    MOV DPTR, #TXCON
    MOVX @DPTR, A           ;           TXCON = TXCLR;
    MOV DPTR, #RSTAT
    MOV A, #8h
    MOVX @DPTR, A           ;           RXSTAT = ISOOVW;
    MOV DPTR, #TXSTAT
    MOVX @DPTR, A           ;           TXSTAT = TXSOVW;
    INC R7
    MOV A, R7
    CJNE A, #6h, L0393      ;       }
    MOV R0, #15h
    MOV A, #1h
    MOVX @R0, A             ;       configured = true;
    SJMP L0394

L0392:                                          ;   } else
    MOV R7, #1h
L0395:                                          ;       for (byte __register(R7) i = 1; i != 6; ++i) {
    MOV DPTR, #EPINDEX
    MOV A, R7
    MOVX @DPTR, A           ;           EPINDEX = i;
    MOV DPTR, #EPCON
    CLR A
    MOVX @DPTR, A           ;           EPCON = 0;
    INC R7
    MOV A, R7
    CJNE A, #6h, L0395      ;       }
L0394:                                          ;   }
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;   EPINDEX = 0;
    RET                     ;}

clear_feature:                                  ;void clear_feature() {
    MOV R0, #17h
    MOVX A, @R0
    ANL A, #3h              ;   switch (request.bmRequestType & 3) // Recipient
    DEC A
    JZ L0347
    DEC A
    JZ L0348
    ADD A, #2h
    JNZ L0349               ;   case 0: // Device
    MOV R0, #19h
    MOVX A, @R0
    CJNE A, #1h, L0350      ;       if (LOBYTE(request.wValue) == 1) { // DEVICE_REMOTE_WAKEUP
    CLR A
    MOV R0, #14h
    MOVX @R0, A             ;            remote_wakeup = 0;
    RET

L0350:                                          ;       }
    SJMP L0349              ;       EPCON.RXSTL = EPCON.TXSTL = 1; return;

L0348:                                          ;   case 2: // Endpoint
    MOV R0, #19h
    MOVX A, @R0
    JNZ L0351               ;       if (LOBYTE(request.wValue) == 0) { // ENDPOINT_HALT
    MOV R0, #1Bh
    MOVX A, @R0
    ANL A, #0Fh
    MOV DPTR, #EPINDEX
    MOVX @DPTR, A           ;           EPINDEX = LOBYTE(request.wIndex) & 0x0F;
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ANL A, #3Fh
    MOVX @DPTR, A           ;           EPCON.RXSTL = EPCON.TXSTL = 0;
    INC DPTR
    MOV A, #8h
    MOVX @DPTR, A           ;           RXSTAT = ISOOVW;
    MOV DPTR, #TXSTAT
    MOVX @DPTR, A           ;           TXSTAT = 0x08;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    RET                     ;           return;

L0351:                                          ;       }
    SJMP L0349              ;       EPCON.RXSTL = EPCON.TXSTL = 1; return;

L0349:                                          ;   case 3: // Other
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = 1;
L0347:                                          ;   }
    RET                     ;}

    

get_status:                                     ;void get_status() {
    MOV R0, #5Ch
    CLR A
    MOVX @R0, A
    INC R0
    MOV A, #2h
    
    MOVX @R0, A             ;   tx_rx_count = 2;
    CLR A
    MOV R0, #18h
    MOVX @R0, A             ;   report[1] = 0;
    DEC R0
    MOVX A, @R0
    ANL A, #3h              ;   switch (request.bmRequestType & 3) { // Recipient
    DEC A
    JZ L0337                ;       // case 1
    DEC A
    JZ L0338                ;       // case 2
    ADD A, #2h
    JNZ L0339               ;   case 0: // Device
    MOV R0, #14h
    MOVX A, @R0
    JZ L0340                ;       if (remote_wakeup != 0) {
    MOV R0, #17h
    MOV A, #2h
    MOVX @R0, A             ;           report[0] = 2; // Remote wakeup
    RET
L0340:                                          ;       } else {
    CLR A
    MOV R0, #17h
    MOVX @R0, A             ;           report[0] = 0;
    RET                     ;       }
        ;       break;

L0338:                                          ;   case 2: // Endpoint
    MOV R0, #1Bh
    MOVX A, @R0
    ANL A, #0Fh
    MOV DPTR, #EPINDEX
    MOVX @DPTR, A           ;       EPINDEX = LOBYTE(request.wIndex) & 0x0F;
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    JB ACC.7, L0341         ;       if (EPCON.RXSTL
    MOVX A, @DPTR
    JNB ACC.6, L0342        ;       or EPCON.TXSTL) {
L0341:
    MOV R0, #17h
    MOV A, #1h
    MOVX @R0, A             ;           report[0] = 1;  // Halt
    SJMP L0343

L0342:                                          ;       } else {
    CLR A
    MOV R0, #17h
    MOVX @R0, A             ;           report[0] = 0;
L0343:                                          ;       }
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;       EPINDEX = 0;
    RET                     ;       break;

L0339:                                          ;   case 3:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = 0;
        ;       // fallthrough
L0337:                                          ;   case 1:
    RET                     ;}  }

set_ISPCR:                                      ;void set_ISPCR(byte __register(R7) value) {
    MOV 0E7h, R7            ;   ISPCR = value;
    RET                     ;}


usb_transmit:                                   ;usb_transmit(byte __register(A) endpoint) {
    MOV DPTR, #EPINDEX
    MOVX @DPTR, A           ;   EPINDEX = endpoint;
    MOV R7, #10h
    MOV DPTR, #TXCON
    MOVX A, @DPTR
    ANL A, #0Fh
    ORL A, R7
    MOVX @DPTR, A           ;   TXCON &= 0x0F |= 0x10; // TXCON.TXFFRC = true
    RET                     ;}




set_interface:                                  ;void set_interface() {
    MOV R0, #1Bh
    MOVX A, @R0             ;   switch (LOBYTE(request.wIndex)) {
    DEC A
    JZ L0402                ;       // case 1
    INC A
    JNZ L0403               ;   case 0:
L0402:                                          ;   case 1:
    MOV R0, #19h
    MOVX A, @R0
    SETB C
    SUBB A, #0h
    JC L0404                ;       if (LOBYTE(request.wValue) < 1) {
    SJMP L0403
L0404:
    MOV DPTR, #TXCNT
    CLR A
    MOVX @DPTR, A           ;           TXCNT = 0;
    RET                     ;           return;

L0403:                                          ;       }
                            ;       // fallthrough
                            ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = 0;
    RET                     ;}  }



received_ep0:                                   ;void received_ep0() {
    MOV R0, #57h
    MOV A, #0FEh
    MOVX @R0, A             ;   transmit_addr_mode = XRAM_8;
    INC R0
    MOV A, #0h
    MOVX @R0, A
    INC R0
    MOV A, #17h
    MOVX @R0, A             ;   to_transmit = &report;
    LCALL do_receive        ;   do_receive();
    MOV R0, #16h
    MOVX A, @R0
    CJNE A, #0F0h, L0250    ;   if (request_state != 0xF0) return;
    CLR A
    MOV R0, #5Ch
    MOVX @R0, A
    INC R0
    MOVX @R0, A             ;   tx_rx_count = 0;
    MOV R0, #17h
    MOVX A, @R0
    ANL A, #60h
    ADD A, #0E0h
    JZ L0251                ;   switch (request.bmRequestType & 0x60) { // Type
    ADD A, #20h
    JNZ L0252
    LJMP standard_request   ;   case 0: standard_request(); return; // Standard
L0251:
    LJMP vendor_request     ;   case 0x20: vendor_request(); return; // Vendor
L0252:                                          ;   default:
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = true;
L0250:
    RET                     ;       return;
                            ;   }
                            ;}

receive:                                        ;void receive(R3 == 1,    byte* __register(R2:R1) Xbase16, byte __register(R5) size)
                            ;  or receive(R3 == 0,    byte* __register(R1)    base8,   byte __register(R5) size)
                            ;  or receive(R3 == 0xFE, byte* __register(R1)    Xbase8,  byte __register(R5) size)
                            ;{
    MOV R0, #65h
    MOV A, R3
    MOVX @R0, A             ;   X65 = mode;
    INC R0
    MOV A, R2
    MOVX @R0, A
    INC R0
    MOV A, R1
    MOVX @R0, A             ;   Xw66 = base;
    CLR A
    MOV R7, A
L0305:
    MOV A, R7
    CLR C
    SUBB A, R5
    JNC L0303               ;   for (byte __register(R7) i = 0; i < size; ++i) {
    MOV DPTR, #RXDAT
    MOVX A, @DPTR
    MOV R6, A
    MOV R0, #65h
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    MOV DPL, R7
    MOV DPH, #0h
    MOV A, R6
    LCALL memwrite          ;       memwrite(X65, Xw66, i, RXDAT);
    INC R7
    SJMP L0305              ;   }

L0303:
    RET                     ;}

transmit:                                       ;void transmit(byte __register(R3) mode, word __register(R2:R1) base, byte __register(R5) size) {
    MOV R0, #65h
    MOV A, R3
    MOVX @R0, A             ;   X65 = mode;
    INC R0
    MOV A, R2
    MOVX @R0, A
    INC R0
    MOV A, R1
    MOVX @R0, A             ;   Xw66 = base;

    CLR A
    MOV R7, A
L0274:
    MOV A, R7
    CLR C
    SUBB A, R5
    JNC L0272               ;   for (byte __register(R7) i = 0; i < size; ++i)
    MOV R0, #65h
    MOVX A, @R0
    MOV R3, A
    INC R0
    MOVX A, @R0
    MOV R2, A
    INC R0
    MOVX A, @R0
    MOV R1, A
    MOV DPL, R7
    MOV DPH, #0h
    LCALL memread
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;       TXDAT = memread(mode, base, i);
    INC R7
    SJMP L0274              ;   }
L0272:
    RET                     ;}

    
set_feature:                                    ;void set_feature() {
    MOV R0, #17h
    MOVX A, @R0
    ANL A, #3h              ;   switch (LOBYTE(request.bmRequestType) & 3) { // Recipient
    DEC A
    JZ L0354                ;       // case 1
    DEC A
    JZ L0355                ;       // case 2
    ADD A, #2h
    JNZ L0356               ;   case 0: // Device
    MOV R0, #19h
    MOVX A, @R0
    CJNE A, #1h, L0357      ;       if (LOBYTE(request.wValue) == 1) { // DEVICE_REMOTE_WAKEUP
    MOV R0, #14h
    MOV A, #1h
    MOVX @R0, A             ;           remote_wakeup = 1;
    RET                     ;           return;

L0357:                                          ;       }
    SJMP L0356              ;       EPCON.RXSTL = EPCON.TXSTL = 1; return;

L0355:                                          ;   case 2: // Endpoint
    MOV R0, #19h
    MOVX A, @R0
    JNZ L0358               ;       if (LOBYTE(request.wValue) == 0) { // ENDPOINT_HALT
    MOV R0, #1Bh
    MOVX A, @R0
    ANL A, #0Fh
    MOV DPTR, #EPINDEX
    MOVX @DPTR, A           ;           EPINDEX = LOBYTE(request.wIndex) & 0x0F;
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;           EPCON.RXSTL = EPCON.TXSTL = 1;
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;           EPINDEX = 0;
    RET                     ;           return;

L0358:                                          ;       }
    SJMP L0356              ;       EPCON.RXSTL = EPCON.TXSTL = 1; return;

L0356:                                          ;   case 3: // Other
    MOV DPTR, #EPCON
    MOVX A, @DPTR
    ORL A, #0C0h
    MOVX @DPTR, A           ;       EPCON.RXSTL = EPCON.TXSTL = 1;
L0354:                                          ;   }
    RET                     ;}